#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    int N, M;
    cin >> N >> M;
    int vN[N] = {0};
    int vM[M] = {0};
    for (int i = 0; i < N; i++){
        for (int y = 0; y < M; y++){
            int x;
            cin >> x;
            vN[i] += x;
            vM[y] += x;
        }
    }
    sort(vN, vN + N);
    sort(vM, vM + M);
    int lepota = 0;
    if(N >= 3){
        lepota += (vN[N-1]-vN[0]) + (vN[N-1]-vN[1]);
        int levo = 0;
        int desno = N-2;
        while(levo < desno){
            lepota += abs(vN[levo] - vN[desno]);
            if(levo + 2 < desno) lepota += abs(vN[levo + 2] - vN[desno]);
            levo += 2;
            desno -= 2;
        }
        levo = 1;
        desno = N-3;
        while(levo < desno){
            lepota += abs(vN[levo] - vN[desno]);
            if(levo + 2 < desno) lepota += abs(vN[levo + 2] - vN[desno]);
            levo += 2;
            desno -= 2;
        }
    }
    else if(N == 2) lepota += vN[1] - vN[0];

    if(M >= 3){
        lepota += (vM[M-1]-vM[0]) + (vM[M-1]-vM[1]);
        int levo = 0;
        int desno = M-2;
        while(levo < desno){
            lepota += abs(vM[levo] - vM[desno]);
            if(levo + 2 < desno) lepota += abs(vM[levo + 2] - vM[desno]);
            levo += 2;
            desno -= 2;
        }
        levo = 1;
        desno = M-3;
        while(levo < desno){
            lepota += abs(vM[levo] - vM[desno]);
            if(levo + 2 < desno) lepota += abs(vM[levo + 2] - vM[desno]);
            levo += 2;
            desno -= 2;
        }
    }
    else if(M == 2) lepota += vM[1] - vM[0];    
    
    cout << lepota;
}