#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

// PROBLEM: B

bool koord_svih_stubova_iste(const vector<pair<int, int>> & stubovi) {
    int x = stubovi[0].first;
    int y = stubovi[0].second;
    for (int i = 1; i < stubovi.size(); ++i)
        if (stubovi[i].first != x || stubovi[i].second != y)
            return false;
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n; cin >> n;
    vector<pair<int, int>> stubovi(n);
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        stubovi[i] = {x, y};
    }

    if (koord_svih_stubova_iste(stubovi)) {
        // cout << "kord svih" << endl;
        int q; cin >> q;
        while (q--) {
            int x, y, L, R;
            cin >> x >> y >> L >> R;

            if ((R-L+1)&1) {
                cout << stubovi[0].first*2 - x << " " << stubovi[0].second*2 - y << endl;
            } else {
                cout << x << " " << y << endl;
            }
        }
    }
    else { // bf
        int q; cin >> q;
        while (q--) {
            int x, y, L, R;
            cin >> x >> y >> L >> R; L--; R--;

            int x_end = x, y_end = y;
            for (int i = L; i <= R; ++i) {
                x_end = stubovi[i].first*2 - x;
                y_end = stubovi[i].second*2 - y;
                x = x_end;
                y = y_end;
            }

            cout << x_end << " " << y_end << endl;
        }

    }
    return 0;
}