#include <bits/stdc++.h>

using namespace std;

pair<long long, long long> solve (vector<long long> &iks, vector<long long> &ipsilon, long long sx,  long long sy, long long l, long long d){
    long long resx = iks[d];
    long long resy = ipsilon[d];

    if((d - l) % 2 == 1){
        resx -= iks[l - 1];
        resy -= ipsilon[l-1];
        resx += sx;
        resy += sy;
    }

    else{
        resx += iks[l - 1];
        resy += ipsilon[l-1];
        resx -= sx;
        resy -= sy;
    }
    return make_pair(resx, resy);
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<long long> iks (n+1);
    vector<long long> ipsilon (n+1);
    iks[0] = 0;
    ipsilon[0] = 0;
    long long prethodnox = 0;
    long long prethodnoy = 0;
    for(int i = 1; i <= n; i++){
        int x, y;
        cin >> x >> y;
        iks[i] = 2*x - prethodnox;
        ipsilon[i] = 2*y - prethodnoy;
        prethodnox = iks[i];
        prethodnoy = ipsilon[i];
    }



    long long sx, sy, l, d;
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        cin >> sx >> sy >> l >> d;
        pair<long long, long long> resenje = solve(iks, ipsilon, sx, sy, l, d);
        cout << resenje.first << " " << resenje.second << "\n";
    }
}