#include <iostream>
#include<cmath>
#include<vector>
#include<algorithm>
using namespace std;

int main()
{
    int n, total;
    cin >> n; total = n;
    vector<int> a(n);
    vector<int> nums(10^6);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        nums[a[i]]++;
    }

    sort(a.begin(), a.end());

    int mid = a[n/2];

    total -= nums[mid];

    int sol = 0;
    int carry = 0;
    for (int i = 0; i < n; i+=nums[a[i]]) {
        int cur = a[i];
        if (cur == mid) continue;
        sol++;
        sol += min(carry, nums[cur] - 1);
        carry = nums[cur] - carry - 1;
    }

    sol += carry;
    cout << sol << endl;

    return 0;
}