using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace takmicenje_zadatak2
{
    class Program
    {
        static bool CheckCoordinates(int[,] koordinate, int n)
        {
            for (int i = 0; i < n - 1; i++)
            {
                if (koordinate[i, 0] != koordinate[i + 1, 0] || koordinate[i, 1] != koordinate[i + 1, 1])
                    return false;
            }
                return  true;
        }
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[,] koordinate = new int[n, 2];
            string[] s;
            for (int i = 0; i < n; i++)
            {
                s = Console.ReadLine().Split();
                koordinate[i, 0] = int.Parse(s[0]);
                koordinate[i, 1] = int.Parse(s[1]);
            }
            int q = int.Parse(Console.ReadLine());
            int[,] scenariji = new int[q, 4];
            string[] s1;
            for (int i = 0; i < q; i++)
            {
                s1 = Console.ReadLine().Split();
                scenariji[i, 0] = int.Parse(s1[0]);
                scenariji[i, 1] = int.Parse(s1[1]);
                scenariji[i, 2] = int.Parse(s1[2]) - 1;
                scenariji[i, 3] = int.Parse(s1[3]) - 1;
            }
            if (CheckCoordinates(koordinate, n))
            {
                int x = 2 * koordinate[0, 0] - scenariji[0, 2];
                int y = 2 * koordinate[0, 1] - scenariji[0, 3];
                Console.WriteLine(x + " " + y);
            }
            else
            {
                for (int i = 0; i < q; i++)
                {
                    int tempX = scenariji[i, 0];
                    int tempY = scenariji[i, 1];
                    for (int j = scenariji[i, 2]; j <= scenariji[i, 3]; j++)
                    {
                        tempX = 2 * koordinate[j, 0] - tempX;
                        tempY = 2 * koordinate[j, 1] - tempY;
                    }
                    Console.WriteLine(tempX + " " + tempY);
                }
            }
           
        }
    }
}