n, m = map(int, input().split())
a = [list(map(int, input().split())) for i in range(n)]


def pretty_matrix(a, right, up):
    total = 0

    if right:
        for i in range(n - 1):
            for j in range(m):
                total += abs(a[i+1][j] - a[i][j])

    if up:
        for i in range(n):
            for j in range(m - 1):
                total += abs(a[i][j+1] - a[i][j])

    return total


def shift_up(a):
    return a[1:]+[a[0]]


def shift_right(a):
    ans = []
    for i in range(n):
        ans.append(a[i][1:]+[a[i][0]])

    return ans

swap = False

ans1 = -1
best = []
for i in range(n):
    a = shift_up(a)
    
    pm = pretty_matrix(a, not swap, swap)
    if pm > ans1:
        ans1 = pm
        best = a

ans2 = -1
for i in range(m):
    best = shift_right(best)
    ans2 = max(pretty_matrix(best, swap, not swap), ans2)

print(ans1 + ans2)