#include <iostream>
#include<math.h>

using namespace std;

int zbir_cifara(int n, int stepen)
{
    if(n<10)
        return round(pow(n,stepen));
    return round(pow(n%10,stepen))+zbir_cifara(n/10,stepen);
}

int zbir_cifara(int n)
{
    if(n<10)
        return n;
    return n%10+zbir_cifara(n/10);
}

bool jed0(int n)
{
    if(n%10!=0 && n%10!=1)
        return false;
    if(n<10)
        return true;
    return jed0(n/10);
}

int main()
{
    long long x,y;
    int k;
    cin>> x>>y>>k;
    long long a[k];
    for(int i=0; i<k; i++)
        cin>>a[i];
    if(k>log2(y))
    {
        int suma=0;
        for(int i=0; i<k; i++)
            suma+=a[i];
        int b=1;
        while(suma*b<x){
            b++;
            if(b>18)
            {
                cout<<-1;
                return 0;
            }
        }
        for(int i=b; i<=18; i++)
        {
            if(suma*i>y)
            {
                cout<<-1;
                return 0;
            }
            if(jed0(suma*i) && zbir_cifara(suma*i)==i)
            {
                cout<<suma*i;
                return 0;
            }
        }
    }
    else
    {
        //cout<<zbir_cifara(20528,3);
        for(int n=x; n<=y; n++)
        {
            int s=0;
            for(int i=0; i<k; i++)
            {
                s+=zbir_cifara(n,i+1)*a[i];
            }
            if(s==n)
            {
                cout<<n;
                return 0;
            }
        }
    }
    cout<<-1;
    return 0;
}