#include <iostream>
#include<math.h>

using namespace std;

int zbir_cifara(long long n, int stepen)
{
    if(n<10)
        return round(pow(n,stepen));
    return round(pow(n%10,stepen))+zbir_cifara(n/10,stepen);
}

int zbir_cifara(long long n)
{
    if(n<10)
        return n;
    return n%10+zbir_cifara(n/10);
}

bool jed0(long long n)
{
    if(n%10!=0 && n%10!=1)
        return false;
    if(n<10)
        return true;
    return jed0(n/10);
}

int main()
{
    long long x,y;
    int k;
    cin>> x>>y>>k;
    long long a[k];
    for(int i=0; i<k; i++)
        cin>>a[i];
    if(k==2021)
    {
        long long suma=0;
        for(int i=0; i<k; i++)
            suma+=a[i];
        int b=1;
        while(suma*b<x){
            b++;
            if(b>18)
            {
                cout<<-1;
                return 0;
            }
        }
        for(b=b; b<=18; b++)
        {
            if(suma*b>y)
            {
                cout<<-1;
                return 0;
            }
            if(jed0(suma*b) && zbir_cifara(suma*b)==b)
            {
                cout<<suma*b;
                return 0;
            }
        }
    }
    else if(y-x<=10000000)
    {
        for(int n=x; n<=y; n++)
        {
            int s=0;
            for(int i=0; i<k; i++)
            {
                s+=zbir_cifara(n,i+1)*a[i];
            }
            if(s==n)
            {
                cout<<n;
                return 0;
            }
        }
    }
    cout<<-1;
    return 0;
}