#include <bits/stdc++.h>

using namespace std;

const char nl = '\n';

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //complex<int> v1(1, 1);
    //complex<int> v2(2, 3);
    //complex<int> v3 = v1 + v2;
    //cout << v3.real() << " " << v3.imag() << endl;
    
    int n;
    cin >> n;

    vector<complex<int>> v(n);

    for(int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        complex<int> temp(x, y);
        v[i] = temp;
    }

    vector<complex<int>> poz(n);
    poz[0] = 2 * v[0];
    poz[1] = 2 * v[1];

    for(int i = 2; i < n; ++i) {
        poz[i] = poz[i-2] + 2 * v[i];
    }

    vector<complex<int>> neg(n);
    neg[0] = -2 * v[0];
    neg[1] = -2 * v[1];
    
    for(int i = 2; i < n; ++i) {
        neg[i] = neg[i-2] + (-2 * v[i]);
    }

    int q;
    cin >> q;

    while(q--) {
        int x, y, l, r;
        cin >> x >> y >> l >> r;
        --l, --r;
        complex<int> start(x, y);
        //losa ti je formula, poslednji je uvek poizitivan

        if((r - l + 1) % 2)
            start *= -1;

        if(l == r) {
            complex<int> ans = v[l];
            ans *= 2;
            ans += start;
            cout << ans.real() << " " << ans.imag() << nl;
            continue;
        }

        start += poz[r];
        int ind = l-1;
        if((r + 2) % 2 != (ind + 2) % 2)
            --ind;

        if(ind >= 0)
            start -= poz[ind];

        start += neg[r-1];
        ind = l-1;
        if((r-1+2) % 2 != (ind + 2) % 2)
            --ind;

        if(ind >= 0)
            start -= neg[ind];

        cout << start.real() << " " << start.imag() << nl;
    }

}