#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const char nl = '\n';

ll stepeni[20];
ll x, y, k;

bool check(ll proba) {
    return proba >= x && proba <= y;
}

const ll GRAN = 1e18;

bool proveri(const vector<ll> &v) {
    ll suma = 0;
    for(int i = 0; i < k; ++i) {
        suma += v[i];
        if(suma > GRAN) {
            return 0;
        }
    }
    return 1;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //za k >= 60, moramo da koristimo samo 0 i 1, jer je 2^60 > 10^18
    //10 poena imas sigurica
    //kako su samo 0 i jedinice za k >= 60, radis bitmask bruteforce (2^18 * 18^2 koraka)
    //sada je jedini problem da uradis za k < 60


    cin >> x >> y >> k;
    vector<ll> v(k);
    for(auto &z : v)
        cin >> z;

    if(!proveri(v)) {
        cout << -1 << nl;
        return 0;
    }

    ll suma = accumulate(v.begin(), v.end(), 0LL);

    stepeni[0] = 1;
    for(int i = 1; i < 20; ++i) {
        stepeni[i] = stepeni[i-1] * 10LL;
    }
    
    if(k >= 60) {
        for(int mask = 0; mask < (1<<18); ++mask) {
            ll num = 0;
            ll cnt = 0;
            for(int i = 0; i < 18; ++i) {
                if((mask>>i)&1) {
                    num += stepeni[i];
                    ++cnt;
                }
            }
            if(check(num) && cnt * suma == num) {
                cout << num << nl;
                return 0;
            }
        }
        if(suma == stepeni[18] && check(stepeni[18])) {
            cout << stepeni[18] << nl;
            return 0;
        }
        cout << -1 << nl;
        return 0;
    }

    //ako je manje ili jednako 60 koristi to!!!
    //kako sami brojevi nisu bitni (permutovanje cifara ne menja rezultat, osim u slucaju kada je veci odnosno manji)
    //mislim da ce se svoditi na jedan brute force
    //i onda napisi algoritam za koji ti treba 100 godina da promenis redosled...

}