#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

#define pb push_back
#define x first
#define y second
#define IOS ios_base :: sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define endl "\n"
typedef long long ll;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;

const ll N = 1e6 + 2;
ll dpa[N][2], dpb[N][2], a,b ;

int main()
{
    IOS;
    ll n;
    cin >> n;
    for (ll i = 1; i <= n; i++) {
        cin >> a >> b;
        dpa[i][i % 2] = a + dpa[i - 1][i % 2];
        dpb[i][i % 2] = b + dpb[i - 1][i % 2];
        dpa[i][(i + 1) % 2] = dpa[i - 1][(i + 1) % 2];
        dpb[i][(i + 1) % 2] = dpb[i - 1][(i + 1) % 2];
    }
    ll q;
    cin >> q;
    for (ll i = 0; i < q; i++) {
        ll x, y, l, r;
        cin >> x >> y >> l >> r;
        ll tmpx = dpa[r][r % 2] - dpa[l - 1][r % 2] - dpa[r][(r + 1) % 2] + dpa[l - 1][(r + 1) % 2];
        tmpx *= 2;
        ll tmpy = dpb[r][r % 2] - dpb[l - 1][r % 2] - dpb[r][(r + 1) % 2] + dpb[l - 1][(r + 1) % 2];
        tmpy *= 2;
        if ((r - l + 1) % 2) {
            tmpx -= x;
            tmpy -= y;
        } else {
            tmpx += x;
            tmpy += y;
        }
        cout << tmpx << " " << tmpy << endl;
    }
    return 0;
}