#include <iostream>
#include <vector>
#include <utility>

using namespace std;

int main()
{
    int n;
    cin >> n;

    vector<pair<long long, long long>> stubovi(n);
    for (int i = 0; i < n; ++i)
        cin >> stubovi[i].first >> stubovi[i].second;

    vector<pair<long long, long long>> transformacije(n);
    transformacije[1].first = (stubovi[1].first - stubovi[0].first)*2;
    transformacije[1].second = (stubovi[1].second - stubovi[0].second)*2;
    for (int i = 3; i < n; i+=2)
    {
        transformacije[i].first = transformacije[i-2].first
                                + ((transformacije[i].first - transformacije[i-1].first)*2);
        transformacije[i].second = transformacije[i-2].second
                                + ((transformacije[i].second - transformacije[i-1].second)*2);
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; ++i)
    {
        long long x, y;
        int l, r;
        cin >> x >> y >> l >> r;

        l--;
        r--;

        if (l == r)
        {
            cout << (x+((stubovi[l].first - x)*2)) << " " << (y+((stubovi[l].second - y)*2)) << '\n';
            continue;
        }

        if ((l % 2 == 1) && (r % 2 == 0) && ((r - l) == 1))
        {
            cout << x + ((stubovi[r].first - stubovi[l].first) * 2) << " " << y + ((stubovi[r].second - stubovi[l].second) * 2) << '\n';
            continue;
        }

        if (l % 2 == 1)
        {
            x += ((stubovi[l].first - x)*2);
            y += ((stubovi[l].second - y)*2);
        }

        if (r % 2 == 0)
        {
            x += ((stubovi[r].first - x)*2);
            y += ((stubovi[r].second - y)*2);
            r--;
        }

        x += transformacije[r].first - transformacije[l].first;
        y += transformacije[r].second - transformacije[l].second;

        cout << x << " " << y << '\n';
    }

    return 0;
}