#include <bits/stdc++.h>

using namespace std;

// dozvoljena operacija je izabrati 3 proizvoljna indeksa (i, j, k), 1 <= i < j < k <= N
// i postaviti clanove niza Ai, Aj, Ak na srednji po vrednosti od ta tri elementa
// minimalan broj operacija tako da niz A sadrzi sve jednake elemente




// 1 2 2 3 5
// 1 clan levo od 2 2 clana desno
// n = min(leva, desna)
// broj operacija += n
// broj operacija += brojDesnih - n
// broj operacija = max(levi, desni)
// samo jos slucaj kad je na ivici

int solve(vector<int> niz, int n)
{
	map<int, int> brojPon;
	int index = -1;
	int broj = 0;
	for (int i = 0; i < n; i++)
	{
		if (brojPon.find(niz[i]) == brojPon.end())
		{
			brojPon[niz[i]] = 1;
		}
		else brojPon[niz[i]]++;
		if (brojPon[niz[i]] > broj)
		{
			broj = brojPon[niz[i]];
			index = i;
		}
	}	
	
	int brLevo = 0;
	int brDesno = 0;
	
	if (index != 0 && index != n-1) {
		brDesno = n-(index+1);
		int brojac = 0;
		for (int i = 0; i < index; i++)
		{
			if (niz[i] == broj)
				break;
			brojac++;
		}
		brLevo = brojac;
	}
	else
	{
		
	}
	
	return max(brLevo, brDesno);
}

int main()
{	
	/*
	ako su svi razliciti: 
	n = 3 	0 ili 1 operacija
	1 2 3
	1
	n = 5
	1 2 3 2 5
	1 2 2 3 5
	svi elementi razliciti:
	
	// izabere bilo koja 3 broja i uzme srednji
	// ako ima 2 ista uvek uzme ta 2?
	2 2 10
	
	prebrojim jedne i druge
	krenem da menjam ove koji su manji
	min (brojManjih)
	
	ako ima 2 razlicite vrednosti
	2 operacije
	
	operacija moze da promeni jednog ili 2 clana
	u najboljem slucaju svaki put menja 2 clana
	(n-brojClanovaNajveceg+1)/2
	// 
	
	*/

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	
	vector<int> niz;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		niz.push_back(x);
	}
	
	sort(niz.begin(), niz.end());
	cout << solve(niz, n);
	
	return 0;
}