#include <bits/stdc++.h>
#define ll long long

using namespace std;
/*
2d koordinatni sistem
traka trke je odredjena startnom tackom i sa k stubova
u i-tom delu trke trkaci trce od trenutne pozicije do i- tog stuba, kad 
*/

void resi(ll x, ll y, ll l, ll r, vector<pair<ll,ll>> stubovi, bool isti)
{
	// brute force nacin
	ll x1 = stubovi[l].first;
	ll y1 = stubovi[l].second;
	ll ciljX = 2*x1-x;
	ll ciljY = 2*y1-y;
	
	if (isti) {
		if ((r-l) % 2 == 1) {
			cout << x << " " << y << "\n";
			return;
		}
		else {
			cout << ciljX << " " << ciljY << "\n";
			return;
		}	
	}
	
	for (ll i = l+1; i <= r; i++)
	{
		ciljX = 2*stubovi[i].first-ciljX;
		ciljY = 2*stubovi[i].second-ciljY;
	}
	
	cout << ciljX << " " << ciljY << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, q;
	cin >> n;
	vector<pair<ll,ll>> stubovi;
	bool isti = true;
	for (ll i = 0; i < n; i++)
	{
		ll x, y;
		cin >> x >> y;
		if (i > 0)
		{
			if (x != stubovi[0].first || y != stubovi[0].second)
			{
				isti = false;
			}
		}
		stubovi.push_back(make_pair(x, y));
	}
	cin >> q;
	
	for (ll i = 0; i < q; i++)
	{
		ll x, y, l, r;
		cin >> x >> y >> l >> r;
		l--; r--;
		resi(x, y, l, r, stubovi, isti);
	}
	
	return 0;
}