#include <iostream>
//#include <iomanip>
#include <cmath>
//#include <algorithm>
//#include <string>
//#include <vector>
//#include <utility>
//#include <ctime>
//#include <cctype>
//#include <cstdlib>
//#include <limits>
//#include <mycpp.h>

using namespace std;

typedef unsigned long long ull;





void Ispis(ull *a, int n, int m)
{
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			cout << *(a + i*m + j) << " ";
		}
		cout << endl;
	}
}


void NakreniLevo(ull *a, int n, int m)
{
	for(int i = 0; i < n; i++)
	{
		int t = *(a + i*m);
		for(int j = 0; j < m-1; j++)
			*(a + i*m + j) = *(a + i*m + j+1);
		*(a + i*m + m-1) = t;
	}
}

void NakreniGore(ull *a, int n, int m)
{
	for(int j = 0; j < m; j++)
	{
		int t = *(a + j);
		for(int i = 0; i < n-1; i++)
			*(a + i*m +j) = *(a + (i+1)*m + j);
		*(a + (n-1) * m + j) = t;
	}
}

int Sreca(ull *a, int n, int m)
{
	int S = 0;
	if(n > 1)
	{
		for(int i = 0; i < n-1; i++)
			for(int j = 0; j < m; j++)
				S += abs(*(a + (i+1)*m +j) - *(a + i*m +j));
	}
	if(m > 1)
	{
		for(int j = 0; j < m-1; j++)
			for(int i = 0; i < n; i++)
				S += abs(*(a + i*m +j+1) - *(a + i*m +j));
	}
	return S;
}


int Sreca1(ull *a, int n, int m)
{
	int S = 0;
	for(int i = 0; i < m-1; i++)
	{
		S+=abs(*(a +i+1) - *(a+i));
	}
}



void Upis(ull *a, int n, int m)
{
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++)
			cin >> *(a + i*m + j);
}

int slucaj1(ull *a, int n, int m)
{
	int max = Sreca1(a,n,m);
	for(int i = 0; i < m-1; i++)
	{
		NakreniLevo(a, n, m);
		int tr = Sreca1(a, n ,m);
		if(tr > max)
			max = tr;
		Ispis(a,n,m);
		cout << tr << endl;
	}
	return max;
}

int main()
{
	int n, m;
	cin >> n >> m;
	ull a [n][m];
	Upis(&a[0][0], n, m);
	if(n == 1 )
		cout << slucaj1(&a[0][0], n, m) << endl;
	else
		cout << "4";
}