#include <iostream>
//#include <iomanip>
#include <cmath>
#include <algorithm>
//#include <string>
//#include <vector>
//#include <utility>
//#include <map>
//#include <ctime>
//#include <cctype>
//#include <cstdlib>
//#include <limits>
//#include <mycpp.h>

using namespace std;

typedef long long ll;


ll Slucaj(ll a[], int n, ll x)
{
	ll brPoteza = 0;
	for(int i = 0; i < n; i++)
		brPoteza += abs(a[i] - (x + i));
	return brPoteza;
}

int brojLevo(ll a[], int n, ll x)
{
	for(int i = 0; i < n ; i++)
		if(a[i] > x)
			return i;
	return n;
}

ll NoviSlucaj(ll zl[], int n, ll x, ll prvoX, ll prviSlucaj)
{
	if(x > prvoX)
	{
		int levo = brojLevo(zl, n, x);
		int pomeraj = x - prvoX;
		return prviSlucaj + (pomeraj * levo) - (pomeraj * (n - levo));
	}
	else
	{
		int levo = brojLevo(zl, n, x);
		int pomeraj = prvoX - x;
		return prviSlucaj - (pomeraj * levo) + (pomeraj * (n - levo));
	}
}

int main()
{
	int n;
	cin >> n;
	ll zlatnici[n];
	for(int i = 0; i < n; i++)
		cin >> zlatnici[i];
	int q;
	cin >> q;
	ll pocetak[q];
	for(int i = 0; i < q; i++)
		cin >> pocetak[i];
	sort(zlatnici, zlatnici + n);
	
	ll prvoResenje = Slucaj(zlatnici, n, pocetak[0]);
	cout << prvoResenje << endl;
	for(int i = 1; i < q; i++)
		cout << NoviSlucaj(zlatnici, n, pocetak[i], pocetak[0], prvoResenje) << endl;
}