/**
 *    author:  milos
 *    created: 25.04.2021 10:14:03       
**/
#include <bits/stdc++.h>
 
using namespace std;
 
int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> x(n), y(n);
  vector<long long> sumx(n), sumy(n);
  vector<vector<long long>> altx(n, vector<long long>(2)), alty(n, vector<long long>(2));
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
    if (i == 0) {
      sumx[i] = x[i];
      sumy[i] = y[i];
      altx[i][0] = 2 * x[i];
      alty[i][0] = 2 * y[i]; 
    } else {
      sumx[i] = sumx[i - 1] + x[i];
      sumy[i] = sumy[i - 1] + y[i];
      altx[i][0] = altx[i - 1][0]; 
      altx[i][1] = altx[i - 1][1];
      altx[i][i % 2] += 2 * x[i];
      alty[i][0] = alty[i - 1][0]; 
      alty[i][1] = alty[i - 1][1];
      alty[i][i % 2] += 2 * y[i];
    }
  }
  auto SolveX = [&](int sx, int L, int R) {
    long long Sx = altx[R][R % 2] - altx[R][(R % 2) ^ 1];
    if (L > 0) {
      Sx -= altx[L - 1][R % 2];
      Sx += altx[L - 1][(R % 2) ^ 1];
    }
    return Sx + ((R - L + 1) % 2 == 0 ? sx : -sx);
  };
  auto SolveY = [&](int sy, int L, int R) {
    long long Sy = alty[R][R % 2] - alty[R][(R % 2) ^ 1];
    if (L > 0) {
      Sy -= alty[L - 1][R % 2];
      Sy += alty[L - 1][(R % 2) ^ 1];
    }
    return Sy + ((R - L + 1) % 2 == 0 ? sy : -sy);
  };
  int qq;
  cin >> qq;
  while (qq--) {
    int xx, yy, l, r;
    cin >> xx >> yy >> l >> r;
    --l; --r;
    cout << SolveX(xx, l, r) << " " << SolveY(yy, l, r) << '\n';
  }
  return 0;
}