/**                                        
 *    author:  milos
 *    created: 25.04.2021 09:15:40       
**/
#include <bits/stdc++.h>
 
using namespace std;
 
int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector<vector<int>> a(n, vector<int>(m));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> a[i][j];
    }
  }            
  vector<long long> row(n), col(m);
  for (int i = 0; i < n; i++) {
    long long sum = 0;
    for (int j = 1; j < m; j++) {
      sum += abs(a[i][j] - a[i][j - 1]);
    }        
    col[0] += sum;
    for (int j = 1; j < m; j++) {
      sum -= abs(a[i][j] - a[i][j - 1]);
      sum += abs(a[i][j - 1] - a[i][(j - 2 + m) % m]);
      col[j] += sum;  
    }
  }
  for (int j = 0; j < m; j++) {
    long long sum = 0;
    for (int i = 1; i < n; i++) {
      sum += abs(a[i][j] - a[i - 1][j]);
    }
    row[0] += sum;
    for (int i = 1; i < n; i++) {
      sum -= abs(a[i][j] - a[i - 1][j]);
      sum += abs(a[i - 1][j] - a[(i - 2 + n) % n][j]);
      row[i] += sum;
    }
  }
  long long ans = *max_element(row.begin(), row.end()) + *max_element(col.begin(), col.end());
  cout << ans << '\n';
  return 0;
}