#include <iostream>
#include <cstdlib>
#include <algorithm>

std::pair<int, int> opseg(int br, int* a, int n){
    int najm = n, najv = 0;
    int x=0,y=n,z=0;
    while(x<=y){
        z = x+(y-x)/2;
        if(a[z]==br){
            najm = z;
            y=z-1;
        }else if(a[z]>br){
            y=z-1;
        }else{
            x=z+1;
        }
    }
    x=0,y=n,z=0;
    while(x<=y){
        z = x+(y-x)/2;
        if(a[z]==br){
            najv = z;
            x=z+1;
        }else if(a[z]>br){
            y=z-1;
        }else{
            x=z+1;
        }
    }

    //std::cout << najm << " "<<najv << std::endl;
    return std::make_pair(najm, najv);
}

int main()
{
    int n, najv = 0, najm = 1000000;
    int* a;

    std::cin >> n;

    a = (int*) calloc(n, sizeof(int));

    for(int i=0;i<n;++i){
        std::cin >> a[i];
        if(a[i]>najv)
            najv = a[i];
        if(a[i]<najm)
            najm = a[i];
    }

    if(najv == najm){
        std::cout << 0;
        return 0;
    }

    std::sort(a, a+n);

    int rez = n;
    std::pair<int, int> range;
    int br;
    for(int i=0;i<n;++i){
        range = opseg(a[i], a, n);
        br = range.second-range.first+1;
        if(i == 0){
            if(br == 1) continue;

            int temp = n-br;
            if(temp < rez) rez = temp;
        }else if(i == n-1){
            if(br == 1) continue;

            int temp = n-br;
            if(temp < rez) rez = temp;
        }else{
            int d1 = range.first;
            int d2 = n-1-range.second;

            int temp = std::max(d1,d2);
            if(temp < rez) rez = temp;
        }
    }

    std::cout << rez;

    return 0;
}