#include <iostream>

typedef long long lld;

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cerr.tie(0);

    int n, q;
    std::pair<lld, lld>* stub;
    std::pair<lld, lld>* kraj;
    lld x, y, l, r;

    std::cin >> n;
    stub = new std::pair<lld, lld>[n];
    kraj = new std::pair<lld, lld>[n];

    for(int i=0;i<n;++i){
        std::cin >> x >> y;
        stub[i] = std::make_pair(x, y);
    }

    kraj[0].first = stub[0].first*2;
    kraj[0].second = stub[0].second*2;

    for(int i=1;i<n;++i){
        kraj[i].first = stub[i].first+(stub[i].first-kraj[i-1].first);
        kraj[i].second = stub[i].second+(stub[i].second-kraj[i-1].second);
    }

    std::cin >> q;

    std::pair<lld, lld> rez[q];

    int d = 1;
    for(int k=0;k<q;++k){
        std::cin >> x >> y >> l >> r;
        l--;
        r--;

        if((r-l+1)%2==1) d = -1;
        else d = 1;

        if(l==0){
            rez[k].first = kraj[r].first+x*d;
            rez[k].second = kraj[r].second+y*d;
        }else{
            lld dx = x - kraj[l-1].first;
            lld dy = y - kraj[l-1].second;

            rez[k].first = kraj[r].first+dx*d;
            rez[k].second = kraj[r].second+dy*d;
        }
    }

    for(int i=0;i<q;++i){
        std::cout << rez[i].first << " " << rez[i].second << "\n";
    }

    return 0;
}