#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	sort(a.begin(), a.end());
	auto m = a.begin() + a.size() / 2;
	auto l = lower_bound(a.begin(), a.end(), *m);
	auto d = upper_bound(a.begin(), a.end(), *m);

	long long l_cnt = l - a.begin();
	long long d_cnt = a.end() - d;

	cout << max(l_cnt, d_cnt) << endl;
}