#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

vector<int> izdvoj_cifre(int n)
{
	vector<int> cifre;
	while (n > 0)
	{
		cifre.push_back(n % 10);
		n /= 10;
	}
	return cifre;
}

int main()
{
	int x, y, n; cin >> x >> y >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	for (int i = x; i <= y; i++)
	{
		vector<int> cifre = izdvoj_cifre(i);
		int total = 0;
		for (int j = 0; j < n; j++)
		{
			int sum = 0;
			for (int cifra : cifre)
			{
				sum += pow(cifra, j + 1);
			}

			total += a[j] * sum;
			if (total > i)
				break;
		}
		if (total == i)
		{
			cout << i << endl;
			return 0;
		}
	}

	cout << -1 << endl;
	return 0;
}