#include <bits/stdc++.h>
#define ll long long

using namespace std;
//a function to handle singular pillar crossing
pair<ll,ll> trans(pair<ll,ll> r, pair<ll,ll> p){
	r.first+= 2*(p.first-r.first);
	r.second+= 2*(p.second-r.second);
	return r;
}
int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n;
	cin>>n;
	pair<ll,ll> s[n];
	for(ll i =0;i<n;i++){
		ll x,y;
		cin>>x>>y;
		s[i] = pair<ll,ll>(x,y);
	}
	//vector processing
	//we use only the even parts of v
	pair<ll,ll> v[n];
	for(ll i =0;i<n;i+=2){
		v[i] = pair<ll,ll>(0,0);
		v[i].first  = s[i+1].first-s[i].first;
		v[i].second = s[i+1].second-s[i].second;
	}
	//now we make the partial sums
	for(ll i =2;i<n;i+=2){
		v[i].first+=v[i-2].first;
		v[i].second+=v[i-2].second;
	
	}
	//now we handle the requests
	ll q;
	cin>>q;
	while(q--){
		ll l,r;
		ll x0,y0;
	
		cin>>x0>>y0;
		cin>>l>>r;
		pair<ll,ll> coords(x0,y0);
		l--;r--;
		if(r-l==0){coords = trans(coords,s[l]);}
		else if(r-l==1){	coords = trans(coords,s[l]);coords = trans(coords,s[r]);}
		else if(r-l==2){coords = trans(coords,s[l]);coords = trans(coords,s[l+1]);coords = trans(coords,s[r]);}
		else{
			//cout<<-3<<endl;
		//adjust the l
			if(l%2==1){
				coords= trans(coords,s[l]);
				l++;
			}
			else{coords = trans(coords,s[l]);coords = trans(coords,s[l+1]);}
			//cout<<coords.first<<' '<<coords.second<<endl;	
			bool needto = false;
			if(r%2==1){r--;}
			else{needto= true;r-=2;}
			
			//translate the main 
			coords.first += 2*(v[r].first-v[l].first);
			coords.second += 2*(v[r].second-v[l].second);
			//cout<<coords.first<<' '<<coords.second<<endl;
			if(needto){coords = trans(coords, s[r+2]);}
		}
		cout<<coords.first<<' '<<coords.second<<endl;
		
	}
	return 0;
}