#include <bits/stdc++.h>
using namespace std;

#define ll long long
const ll N = 100001, N1 = 18;
const ll inf = 1e18 + 1;
ll a[N], b[N];
ll cif1[N1], cif2[N1];
ll br1, br2;
ll dp[10];

ll sumacifara(ll x) {
    ll res = 0;
    while (x) {
        res += x % 10;
        x /= 10;
    }
    return res;
}

bool samojedinice(ll x) {
    while (x) {
        if (x % 10 > 1)
            return false;
        x /= 10;
    }
    return true;
}

void napravi(ll cif[], ll x, ll &brx) {
    ll br = 0;
    ll x1 = x;
    while (x1) {
        x1 /= 10;
        br++;
    }
    brx = br;
    br--;
    while (x) {
        cif[br--] = x % 10;
        x /= 10;
    }
}
void napraviDP(ll n, ll y) {
    for (ll i = 0; i <= 9; i++) {
        ll x = 1;
        for (ll j = 0; j < n; j++) {
            x *= i;
            if (x > 1e18) {
                dp[i] = -1;
                break;
            }
            dp[i] += x * a[j];
            if (dp[i] > 1e18) {
                dp[i] = -1;
                break;
            }
        }
    }
}

ll nadjisumu(ll n) {
    ll suma = 0;
    for (ll i = 0; i < n; i++) {
        suma += a[i];
        if (suma > inf)
            break;
    }
    if (suma > inf)
        return -1;
    return suma;
}
bool proveri(ll x) {
    ll resenje = 0;
    ll x1 = x;
    ll cifre[10] = {};
    while (x1) {
        cifre[x1 % 10]++;
        x1 /= 10;
    }
    for (ll i = 0; i < 9; i++) {
        if (dp[i] == -1 && cifre[i] != 0)
            return false;
        if (dp[i] * cifre[i] > x)
            return false;
        resenje += dp[i] * cifre[i];
        if (resenje > x)
            return false;
    }
    if (resenje == x)
        return true;
    return false;
}

void solve() {
    ll n, x, y;
    cin >> x >> y >> n;
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    napraviDP(n, y);
    napravi(cif1, x, br1);
    napravi(cif2, y, br2);
    ll suma = nadjisumu(n);
    if (suma == -1 || suma > y) {
        cout << -1 << endl;
        return;
    }
    if (y - x <= 1e7) {
        for (ll i = x; i <= y; i++) {
            if (proveri(i)) {
                cout << i << endl;
                return;
            }
        }
        cout << -1 << endl;
        return;
    }
    if (n == 1) {
        for (ll i = 1; i <= 9 * 17; i++) {
            ll resenje = i * a[0];
            if (resenje >= x && resenje <= y && sumacifara(resenje) == i) {
                cout << resenje << endl;
                return;
            }
        }
        cout << -1 << endl;
        return;
    }
    if (n >= 60) {
        for (ll i = 1; i <= 17; i++) {
            if (suma * i > 1e18) {
                break;
            }
            ll resenje = suma * i;
            if (resenje >= x && resenje <= y && i == sumacifara(resenje) && samojedinice(resenje)) {
                cout << resenje << endl;
                return;
            }
        }
        cout << -1 << endl;
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    solve();
    return 0;
}