#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    pair<int, int> stub[n];
    for (int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        stub[i] = {x, y};
    }
    long long prefixSumX[n], prefixSumY[n];
    prefixSumX[0] = stub[0].first;
    prefixSumY[0] = stub[0].second;
    int pr = -1;
    for (int i = 1; i < n; ++i){
        prefixSumX[i] = prefixSumX[i-1] + pr * stub[i].first;
        prefixSumY[i] = prefixSumY[i-1] + pr * stub[i].second;
        pr *= -1;
    }
    int q;
    cin >> q;
    while (q--){
        int x, y, L, D;
        cin >> x >> y >> L >> D;
        L--;
        D--;
        long long potrebaX, potrebaY;
        if (L > 1){
            potrebaX = prefixSumX[D] - prefixSumX[L-1];
            potrebaY = prefixSumY[D] - prefixSumY[L-1];
        }
        else {
            potrebaX = prefixSumX[D];
            potrebaY = prefixSumY[D];
        }
        if (D % 2) {
            potrebaX *= -1;
            potrebaY *= -1;
        }
        if ((D-L)%2) {
            potrebaX -= x;
            potrebaY -= y;
        }
        else {
            potrebaX += x;
            potrebaY += y;
        }
        potrebaX *= 2;
        potrebaY *= 2;
        cout << potrebaX << " " << potrebaY << endl;
    }
    return 0;
}