#include <bits/stdc++.h>

using namespace std;

#define ends endl
#define sp ' '
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define sz(x) ((int)(x.size()))

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    int n;
    cin >> n;

    vec<pair<ll, ll>> a(n + 1);
    for(int i = 1; i <= n; ++i)
        cin >> a[i].fi >> a[i].se;

    for(int i = 1; i <= n; ++i){
        a[i].fi *= 2;
        a[i].se *= 2;
    }

    vec<ll> first_neg_x(n + 1), first_pos_x(n + 1);
    vec<ll> first_neg_y(n + 1), first_pos_y(n + 1);

    bool turn1 = true, turn2 = false;

    for(int i = 1; i <= n; ++i){
        //first_neg_x
        first_neg_x[i] += first_neg_x[i - 1];
        if(turn1) first_neg_x[i] -= a[i].fi;
        else first_neg_x[i] += a[i].fi;

        //first_pos_x
        first_pos_x[i] += first_pos_x[i - 1];
        if(turn2) first_pos_x[i] -= a[i].fi;
        else first_pos_x[i] += a[i].fi;

        turn1 = !turn1;
        turn2 = !turn2;
    }

    turn1 = true, turn2 = false;

    for(int i = 1; i <= n; ++i){
        //first_neg_y
        first_neg_y[i] += first_neg_y[i - 1];
        if(turn1) first_neg_y[i] -= a[i].se;
        else first_neg_y[i] += a[i].se;

        //first_pos_y
        first_pos_y[i] += first_pos_y[i - 1];
        if(turn2) first_pos_y[i] -= a[i].se;
        else first_pos_y[i] += a[i].se;

        turn1 = !turn1;
        turn2 = !turn2;
    }

    int q;
    cin >> q;
    while(q--){
        ll x, y, lb, rb;
        cin >> x >> y >> lb >> rb;

        ll add_x = x, add_y = y;
        ll r = rb - lb + 1;

        if(r % 2 != 0){
            add_x = -x, add_y = -y;
        }
        
        ll ans_x;
        ll ans_y;
        //ans_x
        if(rb % 2 != 0){
            //first_pos_x
            ans_x = a[rb].fi + first_pos_x[rb - 1] + first_neg_x[lb - 1];
            ans_y = a[rb].se + first_pos_y[rb - 1] + first_neg_y[lb - 1];
        }else{
            //first_neg_x
            ans_x = a[rb].fi + first_neg_x[rb - 1] + first_pos_x[lb - 1];
            ans_y = a[rb].se + first_neg_y[rb - 1] + first_pos_y[lb - 1];
        }


        cout << ans_x + add_x << sp << ans_y + add_y << ends;
    }
}