#include <bits/stdc++.h>
using namespace std;

#define long int64_t
#define endl '\n'

#ifdef OFFLINE
    #define logg(x) cerr << #x << ": " << (x) << ", ";
    #define logan(x) cerr << #x << ": " << (x) << endl;
#else
    #define logg(x)
    #define logan(x)
#endif // OFFLINE

struct pr{
    int x, y;

    pr& operator *= (const int q){
        x *= q;
        y *= q;
        return *this;
    }

    pr& operator+= (const pr& o){
        x += o.x;
        y += o.y;
        return *this;
    }

    pr operator+ (const pr& o) const{
        auto tmp = *this;
        return tmp += o;
    }

    pr& operator-= (const pr& o){
        x -= o.x;
        y -= o.y;
        return *this;
    }

    pr operator- (const pr& o) const{
        auto tmp = *this;
        return tmp -= o;
    }

    pr operator- () const{
        auto tmp = pr{-x, -y};
        return tmp;
    }
};

pr a[200'011];
pr p[200'010][2];

int main(){
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    int n; cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i].x >> a[i].y;
        p[i+1][0] = i%2 ? -a[i]+p[i][0] : a[i]+p[i][0];
        p[i+1][1] = i%2 ? a[i]+p[i][1] : -a[i]+p[i][1];
    }

    #ifdef OFFLINE
    for(int i = 0; i <= n; ++i)
        cerr << '(' << p[i][0].x << ", " << p[i][0].y << ") ";
    cerr << endl;
    for(int i = 0; i <= n; ++i)
        cerr << '(' << p[i][1].x << ", " << p[i][1].y << ") ";
    cerr << endl;
    #endif // OFFLINE

    int q; cin >> q;
    for(;q--;){
        pr s;
        int l, r;
        cin >> s.x >> s.y;
        cin >> l >> r;

        int d = r-l+1;
        int ind = (r-1)%2;
        pr tmp = p[r][ind] - p[l-1][ind];
        tmp += d%2 ? -s : s;
        tmp *= 2;

        cout << tmp.x << ' ' << tmp.y << endl;
    }

}