using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        public struct Scenario {

            public int pocetakX;
            public int pocetakY;
            public int opsegMin;
            public int opsegMax;
        }


        public struct Tacka{
            public int x;
            public int y;


            public Tacka(int _x, int _y) {
                x = _x;
                y = _y;
            }

            public static Tacka operator -(Tacka a, Tacka b) {

                return new Tacka(a.x - b.x, a.y - b.y);
            }

            public static Tacka operator +(Tacka a, Tacka b)
            {

                return new Tacka(a.x + b.x, a.y + b.y);
            }

            public void Ispisi() {
                Console.WriteLine("{0} {1}", x, y);
            }
        }


        public static Tacka novaTacka(Tacka pocetnaTacka, Tacka stub) {

            Tacka rastojanje = stub - pocetnaTacka;
            return stub + rastojanje;
        }

        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine()); // broj stubova
            Tacka[] stubovi = new Tacka[n];

            Tacka[] offsets = new Tacka[n];
            
            //unos stubova
            for (int i = 0; i < n; i++)
            {
                string[] stub = Console.ReadLine().Split();
                stubovi[i].x = int.Parse(stub[0]);
                stubovi[i].y = int.Parse(stub[1]);

                Tacka off;
                if (i > 0)
                {
                     off = new Tacka(int.Parse(stub[0]) - stubovi[i - 1].x, int.Parse(stub[1]) - stubovi[i - 1].y);
                }
                else {
                    off = new Tacka(int.Parse(stub[0]), int.Parse(stub[1]));
                }

                offsets[i] = off;
            }

            int q = int.Parse(Console.ReadLine()); // broj scenarija
            Scenario[] scenariji = new Scenario[q];

            //unos scenarija
            for (int i = 0; i < q; i++)
            {
                string[] unos = Console.ReadLine().Split();
                Scenario s = new Scenario();
                s.pocetakX = int.Parse(unos[0]);
                s.pocetakY = int.Parse(unos[1]);
                s.opsegMin = int.Parse(unos[2]);
                s.opsegMax = int.Parse(unos[3]);
                scenariji[i] = s;
            }


            //krajnja pozicija kada se svi stubovi koriste i pocetak je x = 0 i y = 0;

            Tacka trenutnaPozicija = new Tacka(0, 0);
            for (int j = 0; j < n; j++) //prolazak kroz stubove
            {
                trenutnaPozicija = novaTacka(trenutnaPozicija, stubovi[j]);
            }

            Tacka krajnjaPozicija = trenutnaPozicija;
            

            
            
            for (int i = 0; i < q; i++)
            {
                Scenario s = scenariji[i];

                Tacka kraj = krajnjaPozicija;
                for (int j = 0; j < n; j++) //prolazak kroz stubove
                {
                    if (j < s.opsegMin - 1 || j > s.opsegMax - 1) { 
                        //oduzmi offset

                        kraj = kraj - offsets[j];
                    }
                }


                int bStubova = s.opsegMax - s.opsegMin + 1;
                Tacka pocetak = new Tacka(s.pocetakX, s.pocetakY);
                if (bStubova % 2 == 0)
                {
                    kraj += pocetak;
                }
                else
                {
                    kraj-= pocetak;
                }
                kraj.Ispisi();

            }
              
        }
    }
}