using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        public struct Scenario {

            public int pocetakX;
            public int pocetakY;
            public int opsegMin;
            public int opsegMax;
        }


        public struct Tacka{
            public int x;
            public int y;


            public Tacka(int _x, int _y) {
                x = _x;
                y = _y;
            }

            public static Tacka operator -(Tacka a, Tacka b) {

                return new Tacka(a.x - b.x, a.y - b.y);
            }

            public static Tacka operator +(Tacka a, Tacka b)
            {

                return new Tacka(a.x + b.x, a.y + b.y);
            }

            public void Ispisi() {
                Console.WriteLine("{0} {1}", x, y);
            }
        }


        public static Tacka novaTacka(Tacka pocetnaTacka, Tacka stub) {

            Tacka rastojanje = stub - pocetnaTacka;
            return stub + rastojanje;
        }

        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine()); // broj stubova
            Tacka[] stubovi = new Tacka[n];
            
            //unos stubova
            for (int i = 0; i < n; i++)
            {
                string[] stub = Console.ReadLine().Split();
                stubovi[i].x = int.Parse(stub[0]);
                stubovi[i].y = int.Parse(stub[1]);
            }

            int q = int.Parse(Console.ReadLine()); // broj scenarija
            Scenario[] scenariji = new Scenario[q];

            //unos scenarija
            for (int i = 0; i < q; i++)
            {
                string[] unos = Console.ReadLine().Split();
                Scenario s = new Scenario();
                s.pocetakX = int.Parse(unos[0]);
                s.pocetakY = int.Parse(unos[1]);
                s.opsegMin = int.Parse(unos[2]);
                s.opsegMax = int.Parse(unos[3]);
                scenariji[i] = s;
            }

            for (int i = 0; i < q; i++)
            {
                Scenario s = scenariji[i];

                Tacka trenutnaPozicija = new Tacka(s.pocetakX, s.pocetakY);
                
                for (int j = s.opsegMin-1; j <= s.opsegMax-1; j++) //prolazak kroz stubove
                {
                    Tacka t = novaTacka(trenutnaPozicija, stubovi[j]);
                    trenutnaPozicija = t;
                }

                trenutnaPozicija.Ispisi();
            }
        }
    }
}