#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int arr[1005][1005];
int nArr[1005][1005];

int main() {


	int n,m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}

	int indexL = 0, indexG = 0;

	int min_vrsta = 1000000000;

	vector<int> iG;
	vector<int> iL;

	for (int i = 0; i < n-1; i++) {
		int curr = 0;
		for (int j = 0; j < m; j++) {
			curr += abs(arr[i][j] - arr[i+1][j]);
		}

		cout << curr << " : " << endl;

		if (curr <= min_vrsta) {
			indexL = i;
			iL.push_back(indexL);
			min_vrsta = curr;
		}
	}

	int min_kol = 1000000000;

	for (int i = 0; i < m-1; i++) {
		int curr = 0;
		for (int j = 0; j < n; j++) {
			curr += abs(arr[i][j] - arr[i+1][j]);
		}

		if (curr <= min_kol) {
			indexG = i;
			iG.push_back(indexG);
			min_kol = curr;
		}

	}

	long long best = 0;

	if (iG.size() == 0 or iL.size() == 0) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m-1; j++) {
                best += abs(arr[i][j] - arr[i][j+1]);
            }
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n-1; j++) {
                best += abs(arr[j][i] - arr[j+1][i]);
            }
        }
	}

	for (int k = 0; k < iG.size(); k++) {
		for (int r = 0; r < iL.size(); r++) {
			indexG = iG[k];
			indexL = iL[r];
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					nArr[(i + (n-indexL-1)) % n][(j + (m-indexG-1)) % m] = arr[i][j];
				}
			}

			long long ans = 0;

			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m-1; j++) {
					ans += abs(nArr[i][j] - nArr[i][j+1]);
				}
			}

			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n-1; j++) {
					ans += abs(nArr[j][i] - nArr[j+1][i]);
				}
			}

			best = max(best, ans);
		}

	}

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << nArr[i][j] << " ";
	// 	}
	// 	cout << endl;

	// }

	// cout << endl;

	//cout << indexL << " " << indexG << endl;
	cout << best << endl;


	return 0;
}