#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int arr[1005][1005];
int nArr[1005][1005];

int main() {


	int n,m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}

	int indexL = 0, indexG = 0;

	int min_vrsta = 1000000000;

	for (int i = 0; i < n-1; i++) {
		int curr = 0;
		for (int j = 0; j < m; j++) {
			curr += abs(arr[i][j] - arr[i+1][j]);
		}

		if (curr <= min_vrsta) {
			indexL = i;
			min_vrsta = curr;
		}
	}

	int min_kol = 1000000000;

	for (int j = 0; j < m-1; j++) {
		int curr = 0;
		for (int i = 0; i < n; i++) {
			curr += abs(arr[i][j] - arr[i][j+1]);
		}

		if (curr <= min_kol) {
			indexG = j;
			min_kol = curr;
		}

	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			nArr[(i + (n-indexL-1)) % n][(j + (m-indexG-1)) % m] = arr[i][j];
		}
	}


	long long ans = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m-1; j++) {
			ans += abs(nArr[i][j] - nArr[i][j+1]);
		}
	}

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n-1; j++) {
			ans += abs(nArr[j][i] - nArr[j+1][i]);
		}
	}

	//cout << indexL << " " << indexG << endl;
	cout << ans << endl;


	return 0;
}