#include <iostream>

using namespace std;

class Pair
{
public:
	int x, y;
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	Pair stubovi[n];
	for (int i = 0; i < n; ++i)
		cin >> stubovi[i].x >> stubovi[i].y;

	Pair v[n][n];
	for (int i = 0; i < n; ++i)
	{
		v[i][i].x = 0;
		v[i][i].y = 0;
		v[i][i + 1].x = stubovi[i + 1].x - stubovi[i].x;
		v[i][i + 1].y = stubovi[i + 1].y - stubovi[i].y;
		for (int j = i+2; j < n; ++j)
		{
			v[i][j].x = v[i][j - 2].x + (stubovi[j].x - stubovi[j - 1].x);
			v[i][j].y = v[i][j - 2].y + (stubovi[j].y - stubovi[j - 1].y);
		}
	}

	int q;
	cin >> q;



	while (q-- > 0)
	{
		int x, y, l, r;
		cin >> x >> y >> l >> r;

		int d = r - l + 1;
		if (d == 1)
		{
			cout << 2*stubovi[l-1].x-x << " " << 2*stubovi[l-1].y-y << endl;
			continue;
		}

		if (d % 2 != 0)
		{
			x = 2 * stubovi[l - 1].x - x;
				y = 2 * stubovi[l - 1].y - y;
			l++;
		}

		x += 2*v[l-1][r-1].x;
		y += 2*v[l-1][r-1].y;

		cout << x << " " << y << endl;
	}
}