#include <stdlib.h>
#include <stdio.h>

int main()
{
    long N;
    scanf ("%ld", &N);

    long X[N], Y[N];
    for (long i=0; i<N; i++)
        scanf ("%ld%ld", &X[i], &Y[i]);

    long long Xs1[N+1], Ys1[N+1], Xs2[N+1], Ys2[N+1];
    Xs1[0] = 0; Ys1[0] = 0; Xs2[0] = 0; Ys2[0] = 0;

    for (long i=1; i<=N; i++)
        if (i%2==1)
        {
            Xs1[i] = Xs1[i-1] + X[i-1];
            Ys1[i] = Ys1[i-1] + Y[i-1];
            Xs2[i] = Xs2[i-1];
            Ys2[i] = Ys2[i-1];
        }
        else
        {
            Xs1[i] = Xs1[i-1];
            Ys1[i] = Ys1[i-1];
            Xs2[i] = Xs2[i-1] + X[i-1];
            Ys2[i] = Ys2[i-1] + Y[i-1];
        }

    long Q;
    scanf ("%ld", &Q);

    while (Q--)
    {
        long x0, y0, L, R;
        scanf ("%ld%ld%ld%ld", &x0, &y0, &L, &R);

        long long solX, solY;

        if (R%2==1)
        {
            solX = 2*( Xs1[R]-Xs1[L-1] - (Xs2[R]-Xs2[L-1]) );
            solY = 2*( Ys1[R]-Ys1[L-1] - (Ys2[R]-Ys2[L-1]) );
        }
        else
        {
            solX = 2*( Xs2[R]-Xs2[L-1] - (Xs1[R]-Xs1[L-1]) );
            solY = 2*( Ys2[R]-Ys2[L-1] - (Ys1[R]-Ys1[L-1]) );
        }

        if ((R-L+1)%2==1)
        {
            solX -= x0;
            solY -= y0;
        }
        else
        {
            solX += x0;
            solY += y0;
        }

        printf ("%ld %ld\n", solX, solY);
    }

    return 0;
}