#include <iostream>
#include <string>
#include <map>
#include <unordered_map>
#include <set> 
#include <unordered_set>
#include <utility>
using namespace std;
using ll = int64_t;

int bin_pret(const vector<ll>& a, ll l, ll r, ll x) {
    int n = a.size();
    ll ans = 0;

    while (l <= r) {
        ll m = (l + r) / 2ll;
        if (a[m] <= x + m - 1) {
            ans = m;
            l = m + 1;
        }
        else {
            r = m - 1;
        }
    }
    return ans;
}

ll sum(ll l, ll r) {
    if (r < l) return 0;
    ll ls = l * (l + 1ll) / 2ll;
    ll rs = r * (r + 1ll) / 2ll;
    return rs - ls;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n + 1);
    a[0] = 0;
    for (int i = 1; i <= n; ++i) cin >> a[i];

    vector<ll> psum(n + 1);
    psum[0] = 0;
    for (int i = 1; i <= n; ++i) psum[i] = psum[i - 1] + a[i];

    int q;
    cin >> q;
    ll x;
    for (int i = 0; i < q; ++i) {
        cin >> x;
        int g = bin_pret(a, 0, n, x);
        ll lp = sum(x - 1, x + g - 1);
        ll dp = sum(x + g - 1, x + n - 1);

        ll ans = (g != n ? psum[n] - psum[g] - dp : 0) + (lp - psum[g]);
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}