#include <bits/stdc++.h>

using namespace std;

long long stepeni[10][65];
long long programeri[100005];
long long zbirovi[10];
int k;

bool check_solution(long long n) {
    vector<int> digits;
    long long n1=n;
    while(n1>0) {
        digits.push_back(n1%10);
        n1/=10;
    }
    for(int i=0;i<k;i++) {
        long long sum = 0;
        for(auto x : digits) {
            sum += stepeni[x][i];
            //cout << sum << endl;
        }
        n-=sum*programeri[i];
    }

    if(n==0) return true;
    return false;
}

long long find_sol(long long x, long long y) {
    //cout << x << " " << y << endl;
    if(x>y) {
        return -1;
    }
    if(check_solution((x+y)/2)) {
       return (x+y)/2;
    }
    if(x==y) {
        return -1;
    }
    long long s1 = find_sol(x,(x+y)/2);
    if(s1 == -1) {
        return find_sol((x+y)/2+1,y);
    }
    else return s1;
}

int main () {
    for(int i=0;i<10;i++) {
        stepeni[i][0] = i;
    }
    for(int i=0;i<10;i++) {
        for(int j=1;j<65;j++) {
            stepeni[i][j] = stepeni[i][j-1]*i < 0 ? stepeni[i][j-1] : stepeni[i][j-1]*i;
        }
    }
    long long x,y;
    cin >> x >> y >> k;
    for(int i=0;i<k;i++)
    {
        cin >> programeri[i];
    }
    bool sol = false;
     for(int i=x;i<=y;i++) {
        if(check_solution(i)) {
            cout << i;
            sol = true;
            break;
        }
    }
    if(!sol) {
        cout << -1;
    }
}