#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    int N, M;
    cin >> N >> M;
    long long mat[N][M];
    long long vN[N] = {0};
    long long vM[M] = {0};
    for (int i = 0; i < N; i++){
        for (int y = 0; y < M; y++){
            long long x;
            cin >> x;
            mat[i][y] = x;
            if(i != 0) vN[i] += abs(x-mat[i-1][y]);
            if(y != 0) vM[y] += abs(x-mat[i][y-1]);
        }
    }
    for(int i = 0; i < M; i++) vN[0] += abs(mat[0][i]-mat[N-1][i]);
    for(int i = 0; i < N; i++) vM[0] += abs(mat[0][i]-mat[M-1][i]);

long long lepota = 0;
sort(vN, vN + N);
    sort(vM, vM + M);
    for(int i = 1; i < N; i++) lepota += vN[i];
    for(int i = 1; i < M; i++) lepota += vM[i];
    cout << lepota;
}