#include <bits/stdc++.h>

using namespace std;

pair<int, int> solve (vector<pair<int, int> > &stubovi, int sx,  int sy, int l, int d){
    pair<int, int> trenutak = make_pair(sx, sy);
    while(l <= d){
        trenutak.first = stubovi[l - 1].first + stubovi[l - 1].first - trenutak.first;
        trenutak.second = stubovi[l - 1].second + stubovi[l - 1].second - trenutak.second;
        l++;
    }
    return trenutak;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int> > stubovi (n);
    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        stubovi[i] = make_pair(x, y);
    }

    int sx, sy, l, d;
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        cin >> sx >> sy >> l >> d;
        pair<int, int> resenje = solve(stubovi, sx, sy, l, d);
        cout << resenje.first << " " << resenje.second << "\n";
    }
}