n, m = map(int, input().split())
a = [list(map(int, input().split())) for i in range(n)]


def pretty_matrix(a):
    total = 0

    for i in range(n - 1):
        for j in range(m):
            total += abs(a[i+1][j] - a[i][j])

    for i in range(n):
        for j in range(m - 1):
            total += abs(a[i][j+1] - a[i][j])

    return total


def shift_up(a):
    return a[1:]+[a[0]]


def shift_right(a):
    ans = []
    for i in range(n):
        ans.append(a[i][1:]+[a[i][0]])

    return ans


ans = -1
best = []
for i in range(n):
    a = shift_up(a)
    
    pm = pretty_matrix(a)
    if pm > ans:
        ans = pm
        best = a

for i in range(m):
    best = shift_right(best)
    ans = max(pretty_matrix(best), ans)

print(ans)