from collections import defaultdict

n, m = map(int, input().split())
a = [list(map(int, input().split())) for i in range(n)]

# ***
# ---
# ***
# ---
# ***
# ---
memo_ver = [[0 for _ in range(m)] for i in range(n)]
# *-*-*-
memo_hor = [[0 for _ in range(m)] for i in range(n)]

def pretty_matrix(a, right, up):
    if right:
        for i in range(n):
            for j in range(m):
                memo_ver[i][j] = abs(a[(i+1) % n][j] - a[i][j])

    if up:
        for i in range(n):
            for j in range(m):
                memo_hor[i][j] = abs(a[i][(j+1) % m] - a[i][j])

def shift_up(memo):
    return memo[1:] + [memo[0]]

def shift_right(memo):
    ans = []
    for i in range(n):
        ans.append([memo[i][-1]]+memo[i][:-1])

    return ans


pretty_matrix(a, True, True)

while True:
    memo_ver = shift_up(memo_ver)
    sume = []
    for i in range(n - 1):
        sume.append(sum(memo_ver[i]))
    
    if min(sume) == sume[-1]:
        break


while True:
    memo_hor = shift_right(memo_hor)
    sume = []
    for i in range(n):
        suma = 0
        for j in range(m - 1):
            suma += memo_hor[i][j]

        sume.append(suma)

    if min(sume) == sume[-1]:
        break

ans = 0
for i in range(n):
    for j in range(m):
        if i < n - 1:
            ans += memo_ver[i][j]
        
        if j < m -1:
            ans += memo_hor[i][j]

print(ans)