using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication6
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] str = Console.ReadLine().Split();
            int n = int.Parse(str[0]);
            int m = int.Parse(str[1]);

            int[,] a = new int[n, m];
            for (int i = 0; i < n; i++)
            {
                str = Console.ReadLine().Split();
                for (int j = 0; j < m; j++)
                {
                    a[i, j] = int.Parse(str[j]);
                }
            }

            int[,] b = new int[n, m];

            a = PomeriLevo(a, n, m);
            int lepota = LepotaMatrice(a,n,m);

            while(true)
            {             
                b = a;
                a=PomeriLevo(a, n, m);
                int t = LepotaMatrice(a, n, m);
                if (lepota>t)
                {
                    a = b;
                    break;
                }
                lepota = t;
            }

            while (true)
            {
                b = a;
                a=PomeriGore(a, n, m);
                int t = LepotaMatrice(a, n, m);
                if (lepota>t)
                {
                    a = b;
                    break;
                }
                lepota = t;
            }

            //Ispisi(a,n,m);
            Console.WriteLine(lepota);
        }

        static int[,] PomeriLevo(int[,] a,int n,int m)
        {
            int[,] b = new int[n, m];
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                {
                    
                    b[i, j] = a[i,(j + 1) % m];
                   
                }
            }

            return b;
        }

        static int[,] PomeriGore(int[,] a, int n, int m)
        {
            int[,] b = new int[n, m];
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < m; j++)
                {

                    b[i, j] = a[(i+1)%n, j];

                }
            }

            return b;
        }


        static int LepotaMatrice(int[,] a,int n,int m)
        {
            int lepota = 0;
            for (int i = 0; i <n-1 ; i++)
            {
                for (int j = 0; j < m; j++)
                {
                    lepota += Math.Abs(a[i + 1, j] - a[i, j]);
                }
            }

            for (int j = 0; j < m-1; j++)
            {
                for (int i = 0; i < n; i++)
                {
                  lepota+=Math.Abs(a[i,j+1]-a[i,j]);
                }
            }
            return lepota;
        }

        static void Ispisi(int[,] a, int n, int m)
        {
            for (int i = 0; i < n; i++)
            {
                string s = "";
                for (int j = 0; j < m; j++)
                {
                    s += a[i, j] + " ";
                }
                Console.WriteLine(s);
            }
            Console.WriteLine();
        }

    }
}