using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace takmicenje_a3
{
    class Program
    {
        public static long nadjiZbir(long[] brSeljana, int k, long n, byte[] nizCifara)
        {
            long zbir = 0;
            long[] trenutni = new long[k];
            for (int i = 0; i < k; i++)
            {
                trenutni[i] = 0;
            }
            for (int i = 0; i < k; i++)
            {
                for (int j = 0; j < nizCifara.Length; j++)
                {
                    trenutni[i] += brSeljana[i] * (long)Math.Floor(Math.Pow(nizCifara[j], j));
                }
                if (n < trenutni.Sum()) return -1;
                zbir += trenutni[i];
            }
            return zbir;
        }


        static void Main(string[] args)
        {
            long x, y, n;
            int k;
            long[] niz;
            string[] s = Console.ReadLine().Split();
            x = long.Parse(s[0]);
            y = long.Parse(s[1]);
            k = int.Parse(s[2]);
            niz = new long[k];
            s = Console.ReadLine().Split();
            for (int i = 0; i < k; i++)
            {
                niz[i] = long.Parse(s[i]);
            }

            int brCifara = (int)Math.Floor(Math.Log10(x));
            byte[] nizCifara = new byte[brCifara];
            long br = x;
            for (int i = 0; i < brCifara; i++)
            {
                nizCifara[i] = Convert.ToByte(br % 10);
                br /= 10;
            }
            n = x;
            bool uradio = false;
            
            for (int i = brCifara - 1; i >= 0; i--)
            {
                if (nizCifara[i] == 9)
                {
                    nizCifara[i] = 0;
                    nizCifara[i - 1]++;
                    i--;
                }
                else
                {

                    nizCifara[i]++;
                }
                long trenutni = nizCifara[i] * (long)Math.Pow(10, i);
                n += trenutni;
                if (n > y)
                {
                    n -= trenutni;
                    nizCifara[i]--;
                    continue;
                }
                if(nadjiZbir(niz, k, n, nizCifara) == -1)
                {
                    n -= trenutni;
                    nizCifara[i]--;
                }
                else
                {
                    i--;
                    uradio = true;
                }
            }
            if (uradio == false) Console.WriteLine("-1");
            else Console.WriteLine(n);
            Console.ReadLine();

        }
    }
}