#include <iostream>
#include <algorithm>
#define MAXN 200005

#define print(x) cout << #x << " = " << x << endl;

using namespace std;

int n, q;
int a[MAXN];
int sums[MAXN];
int queries[MAXN];

int contsum(int x) { return ((x-1)*x)/2; }
int contsum2(int x, int y) { return ((int)(((float)(x+y))/2)) * (y-x+1); }

bool comp(int first, int second) { return second >= first; }


int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    cin >> q;
    for (int i = 0; i < q; i++)
        cin >> queries[i];

    sums[0] = a[0];
    for (int i = 1; i < n; i++)
        sums[i] = sums[i-1] + a[i];

    //broj elemenata na levoj i desnoj strani
    for (int i = 0; i < q; i++)
    {
        int res = 0;
        int x = queries[i];
        //proveriti kako su elementi rasporedjeni
        int* upper = upper_bound(a, a+n, x, comp);
        if (upper == a)
        {
            res = abs(sums[n-1] - contsum2(a[0], a[0] + n - 1));
        }
        else if (upper == a+n)
        {
            res = abs(contsum2(a[n-1], a[n-1] + n - 1));
        }
        /*else if (upper == a+n-1)
        {

        }*/
        else
        {
            bool exact = false;
            int index = upper - a;
            //print(index)
            int nl = index;
            //print(nl)
            if (a[index] == x) exact = true;
            int nd = n - index;
            //print(nd)
            int poz = x + nd + nl - 1;
            //print(poz)
            int sl = 0, sd = 0;
            if (exact) sl = sums[nl];
            else sl = sums[nl-1]; //?
            if (exact) sd = sums[n-1] - sums[nl];
            else sd = sums[n-1] - sums[nl-1];
            int res_l = 0, res_d = 0;
            //print(sd) print(sl)
            res_l = contsum(nl) + nl * x - sl;
            //print(res_l)
            int cnt = 0;
            for (int j = n-1; j >= index; j--)
            {
                res_d += abs(a[j] - (poz - cnt++));
            }
            //print(res_d);
            res = res_l + res_d;
        }
        cout << res << '\n';
    }
}