#include <iostream>
#include <vector>
#include <cmath>

#define ll long long

using namespace::std;

ll maxValue2(vector<vector<ll>>& a) {
	vector < vector<ll>> poma;
	ll n = a.size(), m = a[0].size(),i,j, sum = 0;
	for (i = 0; i < n; i++) {
		vector<ll> pom;
		for (j = 0; j < m; j++) {
			sum += abs(a[i][(j + 1) % m] - a[i][j]);
			pom.push_back(abs(a[i][(j + 1) % m] - a[i][j]));
		}
		poma.push_back(pom);
	}
	ll mine = 0;
	for (j = 0; j < m; j++) {
		ll minsum = 0;
		for (i = 0; i < n; i++) minsum += poma[i][j];
		if (j == 0) mine = minsum;
		else {
			if (minsum < mine) mine = minsum;
		}
	}
	return sum - mine;
}

ll maxValue(vector<vector<ll>>& a) {
	vector < vector<ll>> poma;
	ll n = a.size(), m = a[0].size(), i, j, sum = 0;
	for (i = 0; i < n; i++) {
		vector<ll> pom;
		for (j = 0; j < m; j++) {
			sum += abs(a[(i+1)%n][j] - a[i][j]);
			pom.push_back(abs(a[i][(j + 1) % m] - a[i][j]));
		}
		poma.push_back(pom);
	}
	ll mine = 0;
	for (i = 0; i < n; i++) {
		ll minsum = 0;
		for (j = 0; j < m; j++) minsum += poma[i][j];
		if (i == 0) mine = minsum;
		else {
			if (minsum < mine) mine = minsum;
		}
	}
	return sum - mine;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<ll>> a;
	for (int i = 0; i < n; i++) {
		vector<ll> pom(m);
		for (int j = 0; j < m; j++)
			cin >> pom[j];
		a.push_back(pom);
	}
	cout << maxValue2(a) + maxValue(a);
	return 0;
}