using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        
        static void Razmena(ref int a, ref int b)
        {
            int p = a;
            a = b;
            b = p;
        }
        static int Srednji(int a, int b, int c)
        {
            if (a > b) Razmena(ref a, ref b);
            if (a > c) Razmena(ref a, ref c);
            if (b > c) Razmena(ref c, ref b);
            return b;
        }
        static bool ImaLiGa(int[] niz, int a)
        {
            for (int i = 0; i < niz.Length; i++)
            {
                if (a == niz[i]) return true;
            }
            return false;
        }
        static bool Stoji(int[] niz, int a)
        { 
            for (int i = 0; i < niz.Length; i++)
            {
                if (a == niz[i]) return true;
            }
            return false;
        }
        static int Najvise(int[] niz, int n, ref int broj_ponavljanja)
        {   
            int res = niz[0];
            int sadasnji_broj = 1;

            for (int i = 1; i < n; i++)
            {
                if (niz[i] == niz[i - 1])sadasnji_broj++;
                else
                {
                    if (sadasnji_broj > broj_ponavljanja)
                    {
                        broj_ponavljanja = sadasnji_broj;
                        res = niz[i - 1];
                    }
                    sadasnji_broj = 1;
                }
            }
            if (sadasnji_broj > broj_ponavljanja)
            {
                broj_ponavljanja = sadasnji_broj;
                res = niz[n - 1];
            }
            return res;
        }
        static int BrojIzmedju(int[] niz, int i1, int i2, int max)
        {
            while (i1 < i2 - 1)
            {
                if (niz[i1 + 1] == max) return i1 + 1;
                i1++;
            }
            return -1;
        }
        static bool SviRazliciti(int[] niz)
        {
            for (int i = 0; i < niz.Length - 1; i++)
            {
                if (niz[i] == niz[i + 1]) return false;
            }
            return true;
        }
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[] niz = new int[n];
            int[] stari_niz = new int[n];
            int broj_ponavljanja = 0;
            string[] str = Console.ReadLine().Split();
            for (int i = 0; i < n; i++)
            {
                niz[i] = int.Parse(str[i]);
                stari_niz[i] = niz[i];
            }


            int[] br = new int[2]

            if (SviRazliciti(stari_niz)) Console.WriteLine(n / 2);
            
        }
    }
}