#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll stepen(ll broj, ll p) {
    ll rez = 0;
    while(broj > 0) {
        rez += pow(broj%10, p);
        //rez += (broj%10)>>10;
        broj /= 10;
    }
    //cout << rez << '\n';
    return rez;
}

int provera(ll kripto, ll sela[], ll k, ll x, ll y) {
    ll broj = 0;
    for(ll i = 0;i < k;i++)
        broj += (stepen(kripto, i+1)*sela[i]);
    //cout << broj << '\n';
    if(broj >= x && broj <= y)
        return 1;
    else if(kripto < broj)
        return 2;
    else if(kripto > broj)
        return 3;
}

ll nadji(ll x, ll y, ll sela[], ll k, ll X, ll Y) {
    ll sred = x + (y - x)/2;
    while(x <= y) {
        if(provera(sred, sela, k, X, Y) == 1)
            return sred;
        else if(provera(sred, sela, k, X, Y) == 2)
            return nadji(sred+1, y, sela, k, X, Y);
        else if(provera(sred, sela, k, X, Y) == 3)
            return nadji(x, sred-1, sela, k, X, Y);
    }
    return -1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll x, y, k;
    cin >> x >> y >> k;
    ll sela[k];
    for(ll i = 0;i < k;i++)
        cin >> sela[i];
    cout << nadji(x, y, sela, k, x, y);
    return 0;
}