#include <iostream>

using namespace std;

int* read(int n){
    int* x=new int[n];
    for(int i=0;i<n;i++){
        scanf("%d", x + i);
    }
    return x;
}

pair<long long, long long>* read2(int n){
    pair<long long, long long>* x=new pair<long long, long long>[n];
    for(int i=0, k = 1;i<n;i++, k*=-1){
        long long a, b;
        scanf("%lld%lld", &a, &b);
        a *= 2*k;
        b *= 2*k;
        if(i>0){
            a+=x[i-1].first;
            b+=x[i-1].second;
        }
        x[i] = make_pair(a, b);
    }
    return x;
}

int main(){
    int n, q;
    cin >> n;
    pair<long long, long long>* s = read2(n);
    cin >> q;

    for(int i=0;i<q;i++){
        long long x, y, l, r;
        scanf("%lld%lld%lld%lld", &x,&y,&l,&r);
        l--;
        r--;
        long long a = s[r].first, b = s[r].second;
        if(l != 0){
            a-=s[l-1].first;
            b-=s[l-1].second;
        }
        int k = 1-2*(r%2);//0->1, 1->-1
        a*=k;
        b*=k;
        k = 1-2*((r-l)%2);
        x*=k;
        y*=k;
        printf("%lld %lld\n", a - x, b - y);
    }

    delete[] s;
    return 0;
}