#include <bits/stdc++.h>

using namespace std;

#define ll long long

// dozvoljena operacija je izabrati 3 proizvoljna indeksa (i, j, k), 1 <= i < j < k <= N
// i postaviti clanove niza Ai, Aj, Ak na srednji po vrednosti od ta tri elementa
// minimalan broj operacija tako da niz A sadrzi sve jednake elemente




// 1 2 2 3 5
// 1 clan levo od 2 2 clana desno
// n = min(leva, desna)
// broj operacija += n
// broj operacija += brojDesnih - n
// broj operacija = max(levi, desni)
// samo jos slucaj kad je na ivici


ll solve(vector<ll> niz, ll n)
{
	// izaberem index za koji je max(brLevo, brDesno) najmanji
	
	map<ll, ll> brojPon;
	for (ll i = 0; i < n; i++)
	{
		if (brojPon.find(niz[i]) == brojPon.end())
		{
			brojPon[niz[i]] = 1;
		}
		else brojPon[niz[i]]++;
	}	
	
	// 5 - 1 = 4
	// 
	// 1 2 2 3 5
	// imam broj ponavljanja za svaki clan
	//
	ll ret = INT_MAX;
	
	for (ll i = 0; i < n; i++)
	{
		ll brLevo = i;
		ll brDesno = n - i - brojPon[niz[i]];
		
		if (max(brLevo, brDesno) < ret)
			ret = max(brLevo, brDesno);
			
		//cout << i+1 << " " << niz[i] << "\n";
		//cout << i+1 << ":" << " Levo od i: " << brLevo << " Desno od i: " << brDesno << "\n";
			
		i += brojPon[niz[i]]-1;
		
		//cout << i+1 << " " << niz[i] << "\n";
		
	}
	
	return ret;
}

int main()
{	
	/*
	n = 5
	1 2 3 2 5
	1 2 2 3 5
	svi elementi razliciti:
	
	// izabere bilo koja 3 broja i uzme srednji
	// ako ima 2 ista uvek uzme ta 2?
	2 2 10
	
	prebrojim jedne i druge
	krenem da menjam ove koji su manji
	min (brojManjih)
	
	ako ima 2 razlicite vrednosti
	2 operacije
	
	operacija moze da promeni jednog ili 2 clana
	u najboljem slucaju svaki put menja 2 clana
	(n-brojClanovaNajveceg+1)/2
	// 
	
	*/

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n;
	cin >> n;
	
	vector<ll> niz;
	for (ll i = 0; i < n; i++)
	{
		ll x;
		cin >> x;
		niz.push_back(x);
	}
	
	sort(niz.begin(), niz.end());
	
	// sortiran niz
	// 1 2 2 3 5
	// nadjem broj za koji je broj levih od max (brLevo, brDesno) najmanji
	
	cout << solve(niz, n);
	
	return 0;
}