#include <iostream>

#define MAX_W 1000
#define MAX_H 1000

int64_t w, h;
int64_t sumHorizontal;
int64_t sumVertical[MAX_H];
int64_t topValues[MAX_W];
int64_t firstTopValues[MAX_W];
int64_t value, leftValue, firstLeftValue;
int64_t minSumHorizontal, minSumVertical;
int64_t sumX, sumY;

inline int64_t abs(int64_t a)
{
    if (a < 0)
        return -a;
    return a;
}

int main()
{
    scanf("%lli%lli", &w, &h);

    sumY = 0;
    sumX = 0;
    minSumHorizontal = LLONG_MAX;
    minSumHorizontal = LLONG_MAX;
    //First row
    {
        //First collumn
        {
            scanf("%lli", &value);
            leftValue = firstLeftValue = value;
            topValues[0] = firstTopValues[0] = value;
        }

        for (int64_t x = 1; x < w; ++x)
        {
            scanf("%lli", &value);

            sumVertical[x - 1] = abs(leftValue - value);
            leftValue = value;

            topValues[x] = firstTopValues[x] = value;
        }

        sumVertical[w - 1] = abs(leftValue - firstLeftValue);
    }


    for (int64_t y = 1; y < h; ++y)
    {
        sumHorizontal = 0;

        //First collumn
        {
            scanf("%lli", &value);
            leftValue = firstLeftValue = value;

            sumHorizontal = abs(topValues[0] - value);
            topValues[0] = value;
        }

        for (int64_t x = 1; x < w; ++x)
        {
            scanf("%lli", &value);

            sumVertical[x - 1] += abs(leftValue - value);
            leftValue = value;

            sumHorizontal += abs(topValues[x] - value);
            topValues[x] = value;
        }

        sumVertical[w - 1] += abs(firstLeftValue - leftValue);

        if (sumHorizontal < minSumHorizontal)
            minSumHorizontal = sumHorizontal;

        sumY += sumHorizontal;
    }

    sumHorizontal = 0;
    for (int64_t x = 0; x < w; ++x)
    {
        sumHorizontal += abs(topValues[x] - firstTopValues[x]);

        sumX += sumVertical[x];

        if (sumVertical[x] < minSumVertical)
            minSumVertical = sumVertical[x];
    }

    sumY += sumHorizontal;

    if (sumHorizontal < minSumHorizontal)
            minSumHorizontal = sumHorizontal;

    printf("%lli", sumX + sumY - minSumVertical - minSumHorizontal);

    return 0;
}