#include <iostream>
#include <algorithm>

#define MAX_N 200000
#define MAX_Q 200000

int64_t positions[MAX_N];
int64_t n, q, x, sum;

int main()
{
    scanf("%lli", &n);

    sum = 0;
    for (int64_t i = 0; i < n; ++i)
    {
        scanf("%lli", positions + i);
        sum += positions[i];
    }

    scanf("%lli", &q);

    for (int64_t i = 0; i < q; ++i)
    {
        scanf("%lli", &x);

        if (x <= positions[0])
        {
            printf("%lli", sum - x * n - (n - 1) * n / 2);
        }
        else if (x + n - 1 >= positions[n - 1])
        {
            printf("%lli", x * n - sum - (n - 1) * n / 2);
        }
        else
        {
            int64_t lowerSum, upperSum;
            int64_t lowerMoves, upperMoves;
            int64_t num = std::lower_bound(positions, positions + n, x) - positions;
            for (int i = 0; i < num; ++i)
                lowerSum += positions[i];
            upperSum = sum - lowerSum;

            lowerMoves = x * num - (lowerSum) - (num - 1) * num / 2;
            num = n - num;
            upperMoves = upperSum - (x + n - num) * num - (num - 1) * num / 2;
            printf("%lli", lowerMoves + upperMoves);
        }
    }

    return 0;
}
/*
5
-2 1 5 6 8
1
2
*/