#include <iostream>

using namespace std;

int partition(int arr[], int low, int high)
{
    int pivot = arr[high];    
    int i = (low - 1); 

    for (int j = low; j <= high - 1; j++)
    {
        if (arr[j] <= pivot)
        {
            i++;
            int t = arr[i];
            arr[i] = arr[j];
            arr[j] = t;
        }
    }
    int t = arr[i + 1]; 
    arr[i + 1] = arr[high];
    arr[high] = t;
    return (i + 1);
}

void quickSort(int arr[], int low, int high)
{
    if (low < high)
    {
        int pi = partition(arr, low, high);

        quickSort(arr, low, pi - 1);
        quickSort(arr, pi + 1, high);
    }
}

bool test(int arr[], int n)
{
    for (int i = 1; i < n; i++)
    {
        if (arr[i] != arr[i - 1])
        {
            return false;
        }
    }
    return true;
}

int main()
{
	int n;
	cin >> n;
	int a[200000];
	float s=0;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
    quickSort(a, 0, n);
    bool t = test(a,n);
    if (!t)
    {
        int sr_index = n / 2;
        int l_index = sr_index - 1;
        int d_index = sr_index + 1;

        a[l_index] = a[sr_index];
        a[d_index] = a[sr_index];
        int counter = 1;
        while (l_index != 0 && d_index != (n - 1))
        {
            l_index--;
            d_index++;
            if (d_index == n)
                d_index--;
            a[l_index] = a[sr_index];
            a[d_index] = a[sr_index];
            counter++;
        }
        cout << counter << endl;
    }
    else
    {
        cout << 0 << endl;
    }
    
	return (0);
}