#include <iostream>

using namespace std;

//long long int stepen(long long int x, int n)
//{
//	long long prag = x;
//	for (int i = 1; i < n; i++)
//	{
//		x *= prag;
//	}
//	return x;
//}

long long int fastExp(long long int base, int exponent) {
	long long int accumulator = 1;
	while (exponent != 0) {
		if (exponent % 2 == 0) {
			base *= base;
			exponent /= 2;
		}
		else {
			exponent -= 1;
			accumulator *= base;
		}
	}
	return accumulator;
}

long long int kriptonit(long long int a[], long long int x, long long int y, int k)
{
	for (long long int i = x; i <= y; i++)
	{
		long long int suma = 0;
		for (int j = 0; j < k; j++)
		{
			long long int z = i;
			long long int sum = 0;
			while (z > 0)
			{
				sum += fastExp(z % 10,j+1);
				z /= 10;
			}
			suma += a[j]*sum;
		}
		if (suma == i)
		{
			return suma;
		}
	}
	return (-1);
}

int main()
{
	long long int x, y;
	int k;
	long long int a[100000];

	cin >> x;
	cin >> y;

	cin >> k;

	for (int i = 0; i < k; i++)
		cin >> a[i];

	cout << kriptonit(a, x, y, k) << endl;

	return (0);
}