#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main()
{
	int n; cin >> n;
	vector<pair<int, int>> stubovi(n);
	for (int i = 0; i < n; i++)
		cin >> stubovi[i].first >> stubovi[i].second;

	vector<int> x_prefix(n + 1);
	vector<int> y_prefix(n + 1);

	int x_curr = 0;
	x_prefix[0] = 0;
	int y_curr = 0;
	y_prefix[0] = 0;
	int sign = 1;
	for (int i = 0; i < n; i++)
	{
		x_curr += sign * stubovi[i].first;
		y_curr += sign * stubovi[i].second;
		x_prefix[i + 1] = x_curr;
		y_prefix[i + 1] = y_curr;
		sign *= -1;
	}

	int q; cin >> q;
	while (q--)
	{
		int x, y; cin >> x >> y;
		int l, r; cin >> l >> r;
		int x_sum = x_prefix[r] - x_prefix[l - 1];
		int y_sum = y_prefix[r] - x_prefix[l - 1];

		if ((r - l) % 2 == 1)
		{
			x_sum *= -1;
			y_sum *= -1;
		}
		
		int n_sign = (r - l) % 2 == 0 ? -1 : 1;
		int x_n = 2 * x_sum + n_sign * x;
		int y_n = 2 * y_sum + n_sign * y;
		cout << x_n << " " << y_n << endl;
	}
}