#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	long long n; cin >> n;
	vector<pair<long long, long long>> stubovi(n);
	for (long long i = 0; i < n; i++)
		cin >> stubovi[i].first >> stubovi[i].second;

	vector<long long> x_prefix(n + 1);
	vector<long long> y_prefix(n + 1);

	long long x_curr = 0;
	x_prefix[0] = 0;
	long long y_curr = 0;
	y_prefix[0] = 0;
	long long sign = 1;
	for (long long i = 0; i < n; i++)
	{
		x_curr += sign * stubovi[i].first;
		y_curr += sign * stubovi[i].second;
		x_prefix[i + 1] = x_curr;
		y_prefix[i + 1] = y_curr;
		sign *= -1;
	}

	long long q; cin >> q;
	while (q--)
	{
		long long x, y; cin >> x >> y;
		long long l, r; cin >> l >> r;
		long long x_sum = x_prefix[r] - x_prefix[l - 1];
		long long y_sum = y_prefix[r] - y_prefix[l - 1];

		if (((r - l) % 2 == 1 && l % 2 == 1) || ((r - l) % 2 == 0 && l % 2 == 0))
		{
			x_sum *= -1;
			y_sum *= -1;
		}
		
		long long n_sign = (r - l) % 2 == 0 ? -1 : 1;
		long long x_n = 2 * x_sum + n_sign * x;
		long long y_n = 2 * y_sum + n_sign * y;
		cout << x_n << " " << y_n << endl;

		//int x_mesto = x;
		//int y_mesto = y;
		//for (int i = l; i <= r; i++)
		//{
		//	int a = stubovi[i - 1].first;
		//	int b = stubovi[i - 1].second;
		//	int dx = a - x_mesto;
		//	int dy = b - y_mesto;
		//	x_mesto += 2 * dx;
		//	y_mesto += 2 * dy;
		//}

		//cout << "brutus: " << x_mesto << " " << y_mesto << endl;
	}
}