#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

int N, M;

int Calc(std::vector<std::vector<int>>& x);
void Shift(std::vector<std::vector<int>>& x, bool isUp);


int main()
{
    int temp, finalRes = 0;
    std::vector<int> tempVec;
    std::vector<std::vector<int>> A;
    std::cin >> N >> M;

    for (int i = 0; i < N; i++)
    {
        tempVec.clear();
        for (int j = 0; j < M; j++)
        {
            std::cin >> temp;
            tempVec.push_back(temp);
        }
        A.push_back(tempVec);
    }

    for (int i = 0; i <= N; i++)
    {
        for (int j = 0; j <= M; j++)
        {
            Shift(A, false);
            if (Calc(A) > finalRes)
                finalRes = Calc(A);
        }
        Shift(A, true);
    }

    std::cout << finalRes;
}

int Calc(std::vector<std::vector<int>>& x)
{
    int res = 0;

    for (int i = 0; i < N-1; i++)
    {
        for (int j = 0; j < M; j++)
        {
            res += std::abs(x[i][j] - x[i+1][j]);
        }
    }
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < M-1; j++)
        {
            res += std::abs(x[i][j] - x[i][j+1]);
        }
    }
    return res;
}


void Shift(std::vector<std::vector<int>>& x, bool isUp)
{
    if (isUp)
    {
        std::rotate(x.begin(), std::next(x.begin()), x.end());
    }
    else
    {
        for (int i = 0; i < N; i++)
            std::rotate(x[i].begin(), std::next(x[i].begin()), x[i].end());
    }
}