#include <bits/stdc++.h>
using namespace std;

#define ll long long

const int N = 200005;

ll odx[N];
ll evx[N];
ll ody[N];
ll evy[N];
ll x[N];
ll y[N];

void printall(int n){
    for(int i = 0; i < n; ++i)
        cout << odx[i] << " ";
    cout << "\n";
    for(int i = 0; i < n; ++i)
        cout << evx[i] << " ";
    cout << "\n";
    for(int i = 0; i < n; ++i)
        cout << ody[i] << " ";
    cout << "\n";
    for(int i = 0; i < n; ++i)
        cout << evy[i] << " ";
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> x[i] >> y[i];
    }

    odx[0] = 0; evx[0] = x[0];
    for(int i = 1; i < n; ++i){
        if(i % 2 == 0){
            evx[i] = x[i] + evx[i - 1];
            odx[i] = odx[i - 1];
        }else{
            odx[i] = x[i] + odx[i - 1];
            evx[i] = evx[i - 1];
        }
    }

    ody[0] = 0; evy[0] = y[0];
    for(int i = 1; i < n; ++i){
        if(i % 2 == 0){
            evy[i] = y[i] + evy[i - 1];
            ody[i] = ody[i - 1];
        }else{
            ody[i] = y[i] + ody[i - 1];
            evy[i] = evy[i - 1];
        }
    }

    //printall(n);
    //return 0;

    int q;
    cin >> q;
    while(q--){
        int sx, sy, l, r;
        cin >> sx >> sy >> l >> r; --l; --r;
        bool lastIsEven = (r - l) % 2 == 0;
        ll resx = 0;
        ll resy = 0;
        ll evxpart = evx[r] - (l > 0 ? evx[l - 1] : 0);
        ll odxpart = odx[r] - (l > 0 ? odx[l - 1] : 0);
        ll evypart = evy[r] - (l > 0 ? evy[l - 1] : 0);
        ll odypart = ody[r] - (l > 0 ? ody[l - 1] : 0);
        if(r % 2 == 0){
            resx = 2 * (evxpart - odxpart);
            resy = 2 * (evypart - odypart);
        }else{
            resx = 2 * (odxpart - evxpart);
            resy = 2 * (odypart - evypart);
        }
        if(lastIsEven){
            resx -= sx;
            resy -= sy;
        }else{
            resx += sx;
            resy += sy;
        }

        cout << resx << " " << resy << "\n";
    }
    return 0;
}

/*
6
2 3
4 5
6 7
8 9
10 11
12 13
3
2 1 1 6
2 1 2 5
2 1 3 5
----
14 13
-6 -7
14 17
*/