#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<double> vd;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<pi> vp;
typedef vector<pl> vpl;

const int maxa = 1e6 + 15;

vi cnt(maxa), pref(maxa), suf(maxa);
vi vis(maxa);

signed main()
{
    ios_base::sync_with_stdio(false); 
    cin.tie(nullptr); 
    cout.tie(nullptr); 
    cerr.tie(nullptr);    

    int n;
    cin >> n;

    vi a(n);
    int maxi = 0, ind = -1;

    for (int i = 0; i < n; ++i){
        cin >> a[i];
        ++cnt[a[i]];
    }

    for (int i = 1; i < maxa; ++i){
        pref[i] = pref[i-1] + cnt[i];
    }

    for (int i = maxa-2; i > 0; --i){
        suf[i] = suf[i+1] + cnt[i];
    }

    int sol = INT32_MAX;
    for (int i = 0; i < n; ++i){
        if (vis[a[i]]) continue;

        int k = min(pref[a[i]-1], suf[a[i] + 1]);

        if (!k && cnt[a[i]] == 1) continue;

        int res = k, x = max(pref[a[i]-1], suf[a[i]+1]) - k;
        res += x;
        sol = min(sol, res);
    }

    cout << sol << '\n';
}