#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<double> vd;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<pi> vp;
typedef vector<pl> vpl;

struct st{
	int x;
	int y;
};

signed main()
{
	ios_base::sync_with_stdio(false); 
	cin.tie(nullptr); 
	cout.tie(nullptr); 
	cerr.tie(nullptr);	

	int n;
	cin >> n;

	vector<st> a(n);
	for (auto& i : a)
		cin >> i.x >> i.y;

	vi sx(n), sy(n);
	sx[0] = a[0].x; sy[0] = a[0].y; 
	for (int i = 1; i < n; ++i){

		int dx = a[i].x, dy = a[i].y;

		if (i % 2){
			dx *= -1;
			dy *= -1;
		}

		sx[i] = sx[i-1] + dx;
		sy[i] = sy[i-1] + dy;
	}

	int q;
	cin >> q;

	for (int e = 0; e < q; ++e){
		int a, b, l, r;
		cin >> a >> b >> l >> r;

		--l;
		--r;

		int dx = sx[r], dy = sy[r];

		if (l>0){
			dx -= sx[l-1];
			dy -= sy[l-1];
		}

		if (r % 2){
			dx *= -1;
			dy *= -1;
		}

		dx *= 2;
		dy *= 2;

		a = dx - a;
		b = dy - b;

		cout << a << ' ' << b << '\n';
	}
}