#include<iostream>

void zameni(int* a, int* b){
	int temp = *a;
	*a = *b;
	*b = temp;
}

int parcelisi(int * niz, int pocetak, int kraj){
	int a, b, c;
	a = niz[pocetak];
	b = niz[kraj];
	c = niz[(pocetak+kraj)/2];

	if((a<b && b<c) || (c<b && b<a))
		zameni(&niz[kraj], &niz[pocetak]);

	if((a<c && c<b) || (b<c && c<a))
		zameni(&niz[(pocetak+kraj)/2], &niz[pocetak]);

	int pivot = niz[pocetak];
	int levo = pocetak + 1;

	for(int i=levo;i<=kraj;i++)
		if(niz[i] < pivot){
			zameni(&niz[i], &niz[levo]);
			levo++;
		}

	zameni(&niz[levo-1], &niz[pocetak]);

	return levo - 1;
}

void QuickSort(int* niz, int pocetak, int kraj){
	if(pocetak < kraj){
		int pivot = parcelisi(niz, pocetak, kraj);
		QuickSort(niz, 0, pivot - 1);
		QuickSort(niz, pivot + 1, kraj);
	}
}

bool NijeOk(int* niz, int duzina){
	for(int i = 0; i < duzina - 1; i++)
		if(niz[i] != niz[i+1])
			return true;
	return false;
}

void Uredi(int* niz, int duzina){
	int a, b, c;

	a = niz[0];
	b = niz[duzina - 1];
	c = niz[(duzina - 1)/2];

	int srVrednost = (a+b+c)/3;

	niz[0] = srVrednost;
	niz[duzina - 1] = srVrednost;
	niz[(duzina - 1)/2] = srVrednost;
}

int main(){
	
	int N;

	std::cin >> N;

	int* niz = (int*)_malloca(N * sizeof(int));

	for(int i=0;i<N;i++)
		std::cin >> niz[i];

	QuickSort(niz, 0, N - 1);

	int br = 0;

	while(NijeOk(niz, N)){
		br++;
		Uredi(niz, N);
		QuickSort(niz, 0, N - 1);
	}

	std::cout << br;
}