#include <iostream>

using namespace std;

bool Zadovoljava(long long n, long long* a, long long k)
{
    long long cifre[18];

    long long temp1 = n;
    for(long long i = 17; i >= 0; i--)
    {
        cifre[i] = temp1 % 10;
        temp1 /= 10;
    }
    long long temp = 0, rez = 0;
    for(long long i = 0; i < k; i++)
    {
        temp = 0;
        for(long long j = 0; j < 18; j++)
        {
            temp += cifre[j];
            cifre[j] *= cifre[j];
        }
        rez += temp * (*(a+i));
    }
    if(rez == n)
        return true;
    else
        return false;
}

int main()
{
    long long x, y, k;
    cin >> x >> y >> k;
    long long a[k];
    for(long long i = 0; i < k; i++)
        cin >> a[i];
    if(x - y > 1000 || x - y < -1000)
    {
        cout << -1;
    }
    else
    {
        bool t = false;
        for(long long i = x; i <= y; i++)
        {
            if(Zadovoljava(i, a, k))
            {
                cout << i;
                t = true;
                break;
            }
        }
        if(t == false)
            cout << -1;
    }
    return 0;
}