def partition(niz, levi, desni):
    i = (levi - 1)
    pivot = niz[desni]

    for j in range(levi, desni):
        if niz[j] <= pivot:
            i = i + 1
            niz[i], niz[j] = niz[j], niz[i]

    niz[i + 1], niz[desni] = niz[desni], niz[i + 1]
    return (i + 1)

def quicksort(niz, levi, desni):
    if len(niz) == 1:
        return niz
    if levi < desni:
        pi = partition(niz, levi, desni)
        quicksort(niz, levi, pi - 1)
        quicksort(niz, pi + 1, desni)



N = int(input())
A = [int(x) for x in input().split()]

quicksort(A, 0, N - 1)

if A[0] == A[N-1]:
    print("0")

elif len(A) % 2 == 1:
    sredina = int(len(A)/2)
    srvr = A[sredina]
    count = 0
    for i in range(1, sredina + 1):
        if A[sredina + i] != srvr and A[sredina - i] != srvr:
            break
        else:
            count += 1
    print(sredina - count)
    
else:
    sredina = int(len(A)/2)
    srvr = A[sredina]
    count = 0
    for i in range(1, sredina):
        if A[sredina + i] != srvr and A[sredina - i] != srvr:
            break
        else:
            count += 1
    print(sredina - count)