#include <stdio.h>
#include <stdlib.h>

#define ABS(x) (((x) > 0)? (x): (-(x)))
#define MIN(x, y) (((x)<(y))? (x): (y))
#define MAT(m, n, i, j) ((n)*(i)+(j))

int main() {
    int n, m;
    scanf("%d%d", &n, &m);

    int *mat = malloc(m*n*sizeof(*mat));
    int i,j;

    for(i=0; i<n; ++i) {
        for(j=0; j<m; ++j) {
            scanf("%d", &mat[MAT(m, n, i, j)]);
        }
    }

    int *kol = calloc(m, sizeof(*kol));
    int *red = calloc(n, sizeof(*red));
    int zbir = 0;

    for(i=0; i<n; ++i) {
        for(j=0; j<m; ++j) {
            if(j != m-1) {
                zbir += ABS(mat[MAT(m, n, i, j)] - mat[MAT(m, n, i, j+1)]);
                kol[j] += ABS(mat[MAT(m, n, i, j)] - mat[MAT(m, n, i, j+1)]);
            } else {
                zbir += ABS(mat[MAT(m, n, i, j)] - mat[MAT(m, n, i, 0)]);
                kol[j] += ABS(mat[MAT(m, n, i, j)] - mat[MAT(m, n, i, 0)]);
            }
        }
    }

    for(i=0; i<m; ++i) {
        for(j=0; j<n; ++j) {
            if(j != m-1) {
                zbir += ABS(mat[MAT(m, n, j, i)] - mat[MAT(m, n, j+1, i)]);
                red[j] += ABS(mat[MAT(m, n, j, i)] - mat[MAT(m, n, j+1, i)]);
            } else {
                zbir += ABS(mat[MAT(m, n, j, i)] - mat[MAT(m, n, 0, i)]);
                red[j] += ABS(mat[MAT(m, n, j, i)] - mat[MAT(m, n, 0, i)]);
            }
        }
    }

    int minX = kol[0], minY = red[0];

    for(i=1; i<m; ++i) {
        minX = MIN(minX, kol[i]);
    }

    for(i=1; i<n; ++i) {
        minY = MIN(minY, red[i]);
    }

    printf("%d\n", zbir - minX - minY);

    return 0;
}