#include <stdio.h>
#include <stdlib.h>

#define ABS(x) (((x) > 0)? (x): (-(x)))

long long bin(long long *niz, long long n, long long vrednost ) {
    long long l=0, d=n-1;
    long long pom;
    while (l < d) {
        pom = (l+d)/2;
        if(niz[pom]==vrednost) {
            return pom;
        }
        if(niz[pom]>vrednost) {
            d = pom;
        } else {
            l = pom;
        }
    }
    return l;
}

int main() {
    long long n;
    scanf("%lld", &n);

    long long *zlat = malloc(n* sizeof(*zlat));
    long long *sume = malloc(n* sizeof(*sume));
    long long i=0;

    scanf("%lld", &zlat[0]);
    sume[0] = zlat[0];
    for(i=1; i<n; ++i){
        scanf("%lld", &zlat[i]);
        sume[i] = sume[i-1] + zlat[i];
    }

    for(i=0; i<n; ++i) {
        printf("%lld ", bin(zlat, n, 5)*6);
    }

    return 0;
}