#include <bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second
using namespace std;

pair<int, int> operator +(const pair<int, int>& f1, const pair<int, int>& s1) {
    return make_pair(f1.fi + s1.fi, f1.se + s1.se);
}

struct hash_pair {
    template <class T1, class T2>
    size_t operator()(const pair<T1, T2>& p) const
    {
        auto hash1 = hash<T1>{}(p.first);
        auto hash2 = hash<T2>{}(p.second);
        return hash1 ^ hash2;
    }
};

int n, q, x, y, l, r;
vector<pair<int,int> > a;
unordered_map<pair<int,int>, pair<int,int>, hash_pair> m;

pair<int,int> getm(pair<int,int> p) {
    if (p.fi >= p.se || p.fi %2 == 0 || p.se%2 == 1)
        return make_pair(0,0);
    if (m.count(p) == 0) {
        if (p.se - p.fi == 1) {
            int h = p.fi;
            m.insert(make_pair(make_pair(h,h+1), make_pair(2*(a[h+1].fi-a[h].fi), 2*(a[h+1].se-a[h].se))));
        } else {
            int h = (p.se-p.fi-1)/2;
            h = p.fi + h;
            h += h%2;
            m.insert(make_pair(p, getm(make_pair(p.fi,h)) + getm(make_pair(h+1,p.se))));
        }
    }
    return m.at(p);
}

int main() {
ios::sync_with_stdio(false);
cin.tie(0);
cout.precision(10);
cout << fixed;

    cin >> n;
    a.resize(n+1);
    for (int i = 1; i <= n; i++) {
        cin >> x >> y;
        a[i] = make_pair(x, y);
    }

    cin >> q;

    for (int i = 0; i < q; i++) {
        pair<int,int> c;
        cin >> c.fi >> c.se >> l >> r;

        if(l%2 == 0) {
            c.fi+= 2*(a[l].fi - c.fi);
            c.se+= 2*(a[l].se - c.se);
            l++;
        }

        if (r-l > 0){
            c = c + getm(make_pair(l,r-r%2));
        }

        if (r%2 == 1) {
            c.fi+= 2*(a[r].fi - c.fi);
            c.se+= 2*(a[r].se - c.se);
        }

        cout << c.fi <<" "<< c.se << endl;
    }

/*
    unordered_map<pair<int,int>, pair<int,int>, hash_pair>::iterator it = m.begin();
    for (it=m.begin(); it!=m.end(); ++it)
        cout << (it->fi).fi << ", " << (it->fi).se << " => " << (it->se).fi << ", " << (it->se).se << '\n';
*/

return 0;
}