#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int32_t n;
int32_t input;
vector<int32_t> a;

void solve()
{
	size_t steps = 0;
	size_t offset = 0;
	sort(a.begin(), a.end());
	int32_t m = n / 2;
	while (offset < m && n - 1 - offset > m)
	{
		int32_t i1 = offset, i2 = m, i3 = n - 1 - offset;
		if (!(a[i1] == a[i2] == a[i3]))
		{
			a[i1] = a[i2] = a[i3] = a[m];
			steps++;
		}
		offset++;
	}
	cout << steps;
}


int main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	cin >> n;
	a.resize(n);

	for (size_t i = 0; i < n; i++)
		cin >> a[i];
	solve();
	return EXIT_SUCCESS;
}