using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Standardan_zadatak1
{
    class Program
    {
        static void razmeni(ref int a, ref int b)
        {
            int p = a;
            a = b;
            b = p;
        }

        static int pivot(int[,] a, int b, int e)
        {
            int i, j = b;
            for (i = b + 1; i <= e; i++)
            {
                if (a[i,0] < a[b,0])
                {
                    razmeni(ref a[i, 0], ref a[j + 1, 0]);
                    razmeni(ref a[i, 1], ref a[j + 1, 1]);
                    j++;
                }
            }
            razmeni(ref a[j,0], ref a[b,0]);
            razmeni(ref a[j, 1], ref a[b, 1]);
            return j;
        }

        static void kviksort(int[,] a, int b, int e)
        {
            int p = pivot(a, b, e);
            if (p - b >= 1)
                kviksort(a, b, p - 1);
            if (e - p >= 1)
                kviksort(a, p + 1, e);
        }
        static void Main(string[] args)
        {
            int p = 1000000;
            int n = int.Parse(Console.ReadLine());
            int[,] a = new int[p, 2];
            int[,] m = new int[p, 4];
            string r = Console.ReadLine();
            string[] l = r.Split();
            int i, o;
            int k = 0;
            for (i = 0; i < n; i++)
            {
                o = int.Parse(l[i]);
                a[o - 1, 0]++;
                if (a[o - 1, 0] == 1)
                {
                    m[k, 0] = o;
                    m[k, 1] = 1;
                    a[o - 1, 1] = k;
                    k++;
                }
                else
                {
                    m[a[o - 1, 1], 1]++;
                }
            }
            kviksort(m, 0, k - 1);
            m[0, 2] = 0;
            m[0, 3] = n - m[0, 1];
            int z = m[0, 3];
            bool t=true;
            for (i = 1; i < k && t; i++)
            {
                int ma;
                m[i, 2] = m[i - 1, 2] + m[i - 1, 1];
                m[i, 3] = n - m[i, 2] - m[i, 1];
                if(m[i,2]>z)
                    t=false;
                else
                {
                    if (m[i, 2] > m[i, 3])
                    ma = m[i, 2];
                else
                    ma = m[i, 3];
                    if (ma < z)
                        z = ma;
                }
            }
            Console.WriteLine(z);
        }
    }
}