#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


bool provera(vector <long long>& v, long long n){
    long long a = 0;
    for (int i = 1; i < n; i++)
        if (v[0] != v[i])
            return false;
    return true;
}

int kirari(long long i, long long j, long long k, vector <long long>& v, long long n, long long t, long long T){
    if (provera(v, n) == true) {
        T = min(t, T);
        return T;
    }
    if (v[i] > min(v[j], v[k]) && v[i] < max(v[j], v[k])){
        v[j] = v[i];
        v[k] = v[i];
    }
    else if (v[j] > min(v[i], v[k]) && v[j] < max(v[i], v[k])){
        v[i] = v[j];
        v[k] = v[j];
    }
    else{
        v[i] = v[k];
        v[j] = v[k];
    }
    if (k < n - 1) return kirari(i, j, k + 1, v, n, t + 1, T);
    if (k < n - 2) return kirari(i, j + 1, k + 1, v, n, t + 1, T);
    if (k < n - 3) return kirari(i + i, j + 1, k + 1, v, n, t + 1, T);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long n;
    cin >> n;
    vector <long long> v(n);
    for (long long i = 0; i < n; i++)
        cin >> v[i];
    long long t = kirari(0, 1, 2, v, n, 0, 200000);
    cout << t << endl;
    return 0;
}