#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long t = 0, T = 200000;

bool provera(vector <long long>& v, long long n){
    long long a = 0;
    for (int i = 1; i < n; i++)
        if (v[0] != v[i])
            return false;
    return true;
}

int kirari(long long i, long long j, long long k, vector <long long>& v, long long n){
    if (provera(v, n) == true){
        T = min(t, T);
    }
    if (v[i] > min(v[j], v[k]) && v[i] < max(v[j], v[k])){
        v[j] = v[i];
        v[k] = v[i];
        t++;
    }
    else if (v[j] > min(v[i], v[k]) && v[j] < max(v[i], v[k])){
        v[i] = v[j];
        v[k] = v[j];
        t++;
    }
    else{
        v[i] = v[k];
        v[j] = v[k];
        t++;
    }
    if (k < n - 1) return kirari(i, j, k + 1, v, n);
    if (k < n - 2) return kirari(i, j + 1, k + 1, v, n);
    if (k < n - 3) return kirari(i + i, j + 1, k + 1, v, n);
    if (k == n - 1 && j == n - 2 && i == n - 3) return T;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long n;
    cin >> n;
    vector <long long> v(n);
    for (long long i = 0; i < n; i++)
        cin >> v[i];
    long long t = kirari(0, 1, 2, v, n);
    if (t != 0) cout << t - 1;
    else cout << t;
    return 0;
}