#include <iostream>
#include <unordered_map>
#include <utility>

using namespace std;

typedef unsigned long long ull;
static ull k, xs[200001], ys[200001];

namespace std
{
    template<> struct hash<pair<ull, ull>>
    {
        inline size_t operator ()(const pair<ull, ull> &a) const
        {
            hash<ull> h;
            return h(a.first) ^ h(a.second);
        }
    };
}

static unordered_map<pair<ull, ull>, pair<ull, ull>> dp[200001];

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> k;
    for (ull i = 1; i <= k; i++)
        cin >> xs[i] >> ys[i];
    ull q;
    cin >> q;
    while (q--)
    {
        ull x, y, l, r;
        cin >> x >> y >> l >> r;
        for (ull i = l; i <= r; i++)
        {
            auto par = make_pair(x, y);
            if (dp[i].find(par) != dp[i].end())
            {
                auto res = dp[i][par];
                x = res.first; y = res.second;
            }
            else
            {
                x = xs[i] + (xs[i] - x);
                y = ys[i] + (ys[i] - y);
                auto par2 = make_pair(x, y);
                dp[i][par] = par2;
            }
        }
        cout << x << ' ' << y << '\n';
    }
    return 0;
}