#include <iostream>
#include <unordered_map>
#include <utility>

using namespace std;

typedef unsigned long long ull;
static ull k, xs[200001], ys[200001];

namespace std
{
    template<> struct hash<pair<ull, ull>>
    {
        inline size_t operator ()(const pair<ull, ull> &a) const
        {
            hash<ull> h;
            return h(a.first) ^ h(a.second);
        }
    };
}

static unordered_map<pair<ull, ull>, ull> dpx, dpy;

int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> k;
    xs[0] = ys[0] = 0;
    cin >> xs[1] >> ys[1];
    xs[1] *= 2; ys[1] *= 2;
    for (ull i = 2; i <= k; i++)
    {
        int x, y;
        cin >> x >> y;
        xs[i] = x * 2 - xs[i - 1];
        ys[i] = y * 2 - ys[i - 1];
    }
    ull q;
    cin >> q;
    while (q--)
    {
        ull x, y, l, r;
        cin >> x >> y >> l >> r;
        ull rezx, rezy;
        if (l & 1)
            if (r & 1)
            {
                rezx = (xs[r] + xs[l - 1]) - x;
                rezy = (ys[r] + ys[l - 1]) - y;
            }
            else
            {
                rezx = (xs[r] - xs[l - 1]) + x;
                rezy = (ys[r] - ys[l - 1]) + y;
            }
        else
            if (r & 1)
            {
                rezx = (xs[r] - xs[l - 1]) + x;
                rezy = (ys[r] - ys[l - 1]) + y;
            }
            else
            {
                rezx = (xs[r] + xs[l - 1]) - x;
                rezy = (ys[r] + ys[l - 1]) - y;
            }
        cout << rezx << ' ' << rezy << '\n';
    }
                // 2*xs[1] - x
                // 2*xs[2] - 2*xs[1] + x
                // 2*xs[3] - 2*xs[2] + 2*xs[1] - x
                // 2*xs[4] - 2*xs[3] + 2*xs[2] - 2*xs[1] + x
                // 2*xs[5] - 2*xs[4] + 2*xs[3] - 2*xs[2] + 2*xs[1] - x
    return 0;
}