#include <bits/stdc++.h>

#define ll long long

using namespace std;

class vec {
public:
    ll x, y;

    vec() {
        x = y = 0;
    }
    vec(ll x, ll y) {
        this->x = x;
        this->y = y;
    }
    void input() {
        cin >> x >> y;
    }
    void output() {
        cout << x << " " << y << endl;
    }
    vec operator+(vec a) {
        return {x + a.x, y + a.y};
    }
    vec operator-(vec a) {
        return {x - a.x, y - a.y};
    }
    vec operator*(ll a) {
        return {a * x, a * y};
    }
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vec p[n];
    for(int i = 0; i < n; i++)
        p[i].input();
    
    vec v[n - 1];
    for(int i = 0; i < n - 1; i++)
        v[i] = (p[i + 1] - p[i]) * 2;

    vec pre[n + 1];
    pre[0] = {0, 0};
    for(int i = 1; i <= n; i++) {
        pre[i] = pre[i - 1];
        if(i % 2 == 0)
            pre[i] = pre[i] + v[i - 2];
    }
    
    int q;
    cin >> q;
    while(q--) {
        vec a;
        int l, r;
        a.input();
        cin >> l >> r;

        if(l % 2 == 0) {
            a = a + ((p[l - 1] - a) * 2);
            l++;
        }
        a = a + (pre[((r % 2 == 0) ? (r) : (r - 1))] - pre[l - 1]);
        if(r % 2)
            a = a + ((p[r - 1] - a) * 2);
        
        a.output();
    }
    return 0;
}