#include <iostream>
#include <string>
#include <map>
#include <unordered_map>
#include <set> 
#include <unordered_set>
#include <utility>
#include <algorithm>
using namespace std;
using ll = int64_t;

ll absll(ll x) {
    return (x < 0 ? -x : x);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) cin >> a[i][j];
    }

    vector<ll> cikl(m, 0), acikl(n, 0);
    for (int i = 0; i < n; ++i) {
        ll p = 0;
        for (int j = 0; j < m - 1; ++j) {
            p += absll(a[i][j + 1] - a[i][j]);
        }
        cikl[0] += p;
        ll x = p;
        for (int j = 1; j < m; ++j) {
            int pre = (m - j - 1) % m;
            int tren = (m - j) % m;
            int posle = (m - j + 1) % m;
            x +=  absll(a[i][posle] - a[i][tren]) - absll(a[i][tren] - a[i][pre]);
            cikl[j] += x;
        }
    }

    for (int j = 0; j < m; ++j) {
        ll p = 0;
        for (int i = 0; i < n - 1; ++i) {
            p += absll(a[i + 1][j] - a[i][j]);
        }
        acikl[0] += p;
        ll x = p;
        for (int i = 1; i < n; ++i) {
            int pre = (n - i - 1) % n;
            int tren = (n - i) % n;
            int posle = (n - i + 1) % n;
            x += absll(a[posle][j] - a[tren][j]) - absll(a[tren][j] - a[pre][j]);
            acikl[i] += x;
        }
    }

    cout << *max_element(cikl.begin(), cikl.end()) + *max_element(acikl.begin(), acikl.end()) << '\n';
}