#include <iostream>
#include <algorithm>
#include <vector>
#include <limits.h>
using namespace std;
typedef long long ll;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	ll n; cin >> n;
	vector<ll> elements(n);
	for (int i = 0; i < n; i++)
	{
		cin >> elements[i];
	}
	sort(elements.begin(), elements.end());

	int sol = INT_MAX;
	for (int i = 1; i < n-1; i++)
	{
		auto lb = lower_bound(elements.begin(), elements.end(), elements[i]);
		auto ub = upper_bound(elements.begin(), elements.end(), elements[i]);
		int greater_cnt = elements.end() - ub;
		int smaller_cnt = lb - elements.begin();
		int ops = max(greater_cnt, smaller_cnt);
		sol = min(ops, sol);
	}
	cout << sol << "\n";

	return 0;
}