//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pii;
const int maxn = 200005;
const int inf = 1e9 + 5;

int n, q;
pii niz[maxn];

ll prefxp[maxn];
ll prefyp[maxn];

ll prefxn[maxn];
ll prefyn[maxn];

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	ff(i,1,n)cin >> niz[i].fi >> niz[i].se;
	
	ff(i,1,n){
		prefxp[i] = prefxp[i - 1] + (i % 2 == 0) * niz[i].fi;
		prefyp[i] = prefyp[i - 1] + (i % 2 == 0) * niz[i].se;
		
		prefxn[i] = prefxn[i - 1] + (i % 2 == 1) * niz[i].fi;
		prefyn[i] = prefyn[i - 1] + (i % 2 == 1) * niz[i].se;
	}
	
	cin >> q;
	while(q--){
		ll A, B;
		int l, r;
		cin >> A >> B >> l >> r;
		
		ll X = 0, Y = 0;
		if((r - l + 1) % 2 == 0){
			
			if(l % 2 == 0){
				X = (prefxn[r] - prefxn[l - 1]) - (prefxp[r] - prefxn[l - 1]); 							
				Y = (prefyn[r] - prefyn[l - 1]) - (prefyp[r] - prefyn[l - 1]); 							
			}
			else{
				X = (prefxp[r] - prefxp[l - 1]) - (prefxn[r] - prefxn[l - 1]); 			
				Y = (prefyp[r] - prefyp[l - 1]) - (prefyn[r] - prefyn[l - 1]); 			
			}
				
			X *= 2;
			X += A;	
			
			Y *= 2;
			Y += B;
			
		}
		else{
			if(l % 2 == 0){
				X = (prefxp[r] - prefxp[l - 1]) - (prefxn[r] - prefxn[l - 1]);
				Y = (prefyp[r] - prefyp[l - 1]) - (prefyn[r] - prefyn[l - 1]);
			}
			else{
				X = (prefxn[r] - prefxn[l - 1]) - (prefxp[r] - prefxn[l - 1]); 	
				Y = (prefyn[r] - prefyn[l - 1]) - (prefyp[r] - prefyn[l - 1]); 	
			}
			
			X *= 2;
			X -= A;
			
			Y *= 2;
			Y -= B;
			
		}
		
		cout << X << " " << Y << '\n';
		
	}
		
	return 0;
}
/*

5
1 1 2 1 1

*/